.TH XRISK 1 "X11" "Programmer's Workshop, NTH"
.SH NAME
xrisk \- X version of Risk boardgame
.SH SYNOPSIS
.B xrisk 
[\| \-m \|] [\| \-d \|] [\| \-l
.I language 
\|]
machine1 machine2
[\| machine3 ... \|]
.SH DESCRIPTION
.PN Xrisk
is a game running under the X window system, that looks very much like
the "Risk" board game published by Parker Brothers, Inc. 
.PP
.SH OPTIONS
.IP \-m
disable missions.
.IP \-d
two active players.
.IP \-l
language to use. See FILES below for what languages are supported.
.SH COMPONENTS
For each player (machine), three windows will appear:
.TP 3
o
.B "Xrisk-info"
where you click on the colour you wish to be represented by, and enter
your player name,
.TP 3
o
.B "Card Info"
which displays the cards you have, and
.TP 3
o
.BI "Xrisk@" machine
which is the main playing board, consisting of the
.I menubuttons,
the
.I message box, 
and the 
.I map.
The menubuttons are described further down. In the message
box will come messages that are distributed to all players, while
messages for you alone will be printed on the bottom of the map. Also,
in the bottom left corner you will see the name of the country and
continent the cursor is positioned in, if any.

.SH BASIC RULES
The object of the game is very simple:
.I "World Conquest"
or
.I "fullfillment of a mission".
To obtain this goal, each player places and moves his own armies on
the board, and attacks the armies of other players until a certain
mission (chosen by the computer) is accomplished, or until the world
is totally conquered. Xrisk might be played with 1 or 2 simultaneously
active players.
.PP
The sequence of play is very straightforward. Each player, in 
turn:
.PP
.TP 3
.B "Exchange cards" \- 
A player might exchange the cards he has received during play. A
player
.I must
exchange cards if the total of cards exceeds four in the beginning of
his turn, or anytime during play when the number of cards exceeds
four. To exchange, the player clicks once on each of the three
required cards to exchange, and the cards will be exchanged when it
becomes that player's turn.  The excnage happens instant|y if the
excange occurs during the turn.  Exchange rates are:
.RS 3
.TP 3
.B "Three artillery" \- 
Gives 
.I four 
additional armies.
.TP 3
.B "Three infantry" \-
Gives 
.I six 
additional armies.
.TP 3
.B "Three cavalry" \-
Gives
.I eight
additional armies.
.TP 3
.B "A combination of all three" \-
Gives
.I ten
additional armies
.PP
.TP 3  
A 
.I joker
might be used as any 
.I one 
of the cards in the exchange.
.PP
If you own the country on the card (any card in the exchange), you
receive a bonus two armies in that country.
.RE
.TP 3
.B "Place Armies" \-
You receive, at the start of your turn, one army for every third
country you own, at a minimum of three, plus one extra if you
conquered a country in your previous turn. If you are the sole
occupant of all areas on a continent, you receive:
.RS 3
.TP 3
.B "North America" \-
.I five
additional armies.
.TP 3
.B "South America" \-
.I two
additional armies.
.TP 3
.B "Europe" \-
.I five
additional armies.
.TP 3
.B "Africa" \-
.I three
additional armies.
.TP 3
.B "Asia" \-
.I seven
additional armies.
.TP 3
.B "Australia" \-
.I two
additional armies.
 
In addition come armies you
got for exchanging cards. All of these armies must be placed in countries
belonging to you. You place the armies by clicking on the country of
your choice. You will then be asked how many armies to place. In this
phase, clicking with the 
.I left 
button again means place all armies there (
.B "Note:"
In the beginning phase only seven armies can be placed in a country.)
while pressing the 
.I right
button means place no armies. You may also type in the number of
armies to put in the country.
.PP
.TP 3
.B "Attack" \-
You can now attack from your countries to neighbouring enemy countries
if you have at least two armies in your country. To attack, click on
the country you wish to attack from, and then on the target coutry.
You may keep doing this (for a given pair of countries) until either
.RS 6
.TP 3
.B o
You have eliminated all the opposing forces,
.TP 3
.B o
You have only one army left, or
.TP 3
.B o
You decide to pull out.
.RE
.RS 3
.PP
You cannot pull out of a fight if you have chosen the 
.I "Do or Die"
option from the menu.
.PP
If you win, you will be asked how many armies to move into the
defeated country. You have to move at least as many armies as those
you attacked with, and at least one army must remain in the attacking
country. These armies are moved automatically by the program, so if
you don't have any armies apart from these, you will not be prompted
for how many you wish to move.  If you are prompted, you may press the
.I left
button to move all the armies (short of the one that must remain), and
the
.I right
button to not move any extra armies. You may also type in the number
of armies to move.
.PP
You end your attacks by clicking in the message window (top right
corner).
.PP
.RE
.TP 3
.B "Move Armies" \-
When you have completed your attack phase, you may move armies. Up to
seven armies can be moved from your countries to neighbouring
countries belonging to you. You then click on the starting country and
the target neighbour, then entering the number you wish to move,
pressing the
.I left
button for maximum number and the
.I right
button for no armies.
.PP
.SH THE MENU
In the top left corner you will see six boxes:
.HP 3
o  A button for
.B "Suicide."
In order to end the game (for you) prematurely, you may double-click
in this box. The text will then change to
.G "End Game,"
and if you click again in the box, the Xrisk display windows will be
removed. The other players will receive a message stating your
suicide, but your armies remain in place until defeated.
.HP 3
o  A button to toggle between
.G "Single Attacks,"
meaning that attacks are conducted one round at a time, and
.G "Do or Die,"
where the machine runs consecutive attacks until one of the end
clauses are met (see above).
.HP 3
o  A button to indicate the number of armies you wish to attack with
per round (the defender uses up to two armies in defence,
automatically), going from 1 to 3. You raise the number by clicking
with the
.I left
button and lower it using the
.I right
button.
.HP 3
o  A button to get a message about what your mission in the game is. If
you complete this mission, you win the game. You can display the text
describing your mission by clicking the
.I left
button in the box, and remove the text by clicking the
.I right
button. The text is displayed at the bottom of the screen.
.HP 3
o  A button to refresh the Xrisk display window, in case some
"unauthorized" resizing has messed up the map or something else has
happened to the display.
.HP 3
o  A small button to enter your own messages in. You can type away, and
terminate with 
.RN .
The message will arrive in the 
.I "message box"
of all the players, with a tag naming the sending player.

.SH FEATURES
Multi\-language\-support \-
.RS 3
The file \<language\>.mapping describes mapping to different
languages.  The environment varable XRISK_MAPDIR describes where to
look for mapfiles and XRISK_LANGUAGE what language to use. We
currently support English, French, German and Norwegian. If you miss
your own language, feel free to make a map-file and send it to us.
.RE

.SH BUGS
Probably plenty. Report any you find to xrisk@pvv.unit.no.

.SH AUTHORS
The program was written by Hans Kristian Nordengen at the Norwegian
Institute of Technology. The X interface was written by Lasse
{\\O}verlier, and this man-page was written by Tor Wilhelmsen.

.SH FILES
Library files normally reside in /local/games/lib/xrisk.
.TP 3
.B Name-conventions:
*.xras    - Run length encoded picture-file read by xrisk.
.br
*.data    - The data file describing countries etc.
.br
*.mapping - Multi language support file.
.TP 3
.B Environment varables:
XRISK_XRASDIR  - where to search for picture-files.
.br
XRISK_DATAFILE - the data file.
.br
XRISK_MAPDIR   - where to search for language-support-files.
.br
XRISK_LANGUAGE - what language to use.
