#include <stdio.h>
#include <sys/types.h>
#include <sys/dir.h>
#include <sys/stat.h>
#include <string.h>
#include <stream.h>

class mapping
{
private:
  char *s[10];
  int oc;
public:
  mapping(char *sent ) 
    { strcpy(s[0] = new char[strlen(sent)+1],sent) ; s[1]=NULL ; oc = 1 ; }
  ~mapping() { for(int t=0;s[t];t++) delete(s[t]); }
  int cons_check(char *);
  void print()
    {
      cout << oc << ' ' ;
      for(int t=0; s[t] ; t++) cout << s[t];
      cout << '\n' ;
    }
};

class maps
{
private:
  mapping maptab[1000];
public:
}

class files
{
private:
  char *names[1024];
  int index;
  int match();
  char *matchrules[100];
public:
  files(int *,int *);
  int register(char *);
  int (*err_ch)();
};

class file_handler
{
private:
  DIR *topdir;
  maps  *mapings;
  files *mapfiles;
  files *datafiles;
  files *xrasfiles
  files *progfiles;
public:
  file_handler();
  int init_files(char *);
  int load_mapfile();
};

files::files(char *rules,int (*err_ch_f)())
{
  char *s1,*s2;
  int t    = 0;
  err_ch   = err_ch_f;
  index    = 0;
  names[0] = NULL;
  strcpy((temp= new char[strlen(rules)+1]),rules);
  for(;;)
    {
      for(s1=s2=temp;*s2!='|' && *s2;s2++);
      if (*s2) break;
      s2=0;
      matchrules[t]=s1;
    }
}

files::register(char *filename)
{
  if (*match)(*filname,
}

file_handler::file_handler()
{
  mapfile   = new files;
  mapfiles  = new files;
  datafiles = new files;
  xrasfiles = new files;
  progfiles = new files;
  for(int t=0;t<1024;maptab[t++]=NULL);
}

int match_last(char *expr,char *file_name)
{
  int a,b;
  for(a=strlen(expr),b=strlen(file_name);a,b,expr[a]==file_name[b];a--,b--);
  if ((a==-1) ||( b==-1)) return(0);
  return(1);
}

int files::init_files(char *path)
{
  int tmp = find_files(path,"mapping",strcmp,mapfile_n);
  
  if (tmp != 1)
    {
      cout << "Found " << tmp << " occurenses of file mapping\n";
      return(1);
    }
  mapfiles_index = 0;
  mapfiles_n[find_files(path,".mapping",match_last,mapfiles_n)] = NULL;
  
  datafiles_index = 0;
  datafiles_n[find_files(path,".data",match_last,datafiles_n)]  = NULL;

  xrasfiles_index = 0;
  xrasfiles_n[find_files(path,".xras",match_last,xrasfiles_n)]  = NULL;
  
  progfiles_index = 0;
  tmp = 0;
  tmp += find_files(path,".c" ,match_last,&xrasfiles_n[tmp]);
  tmp += find_files(path,".cc",match_last,&xrasfiles_n[tmp]);
  tmp += find_files(path,".h" ,match_last,&xrasfiles_n[tmp]);
  xrasfiles_n[tmp]=NULL;
  return(0);
}

files::load_mapfile()
{
  int t;

  fopen(mapfile_n[1024]
  for(t=0;t<1024;t++) maptab[t]=NULL;
  while(buffer = fgets(buffer,199,stdin))
    if ( (*buffer != '!') && (s1=strchr(buffer,'"')) && (s2=strchr(s1+1,'"')))
      {
	*(++s2) = 0;
	if ((t=mapnumber(s1)) != -1)
	  {
	    if (!maptab[t]) maptab[t] = new mapping(s1);
	    else            maptab[t]->cons_check(s1);
	  }
      }
  for(t=0;t<1000;t++) if (maptab[t]) maptab[t]->print();
}
  
int mapping::cons_check(char *sent)
{
  int t;
  oc++;
  for(t=0;s[t];t++) if (!strcmp(s[t],sent)) return(0);
  strcpy(s[t]=new char[strlen(sent)+1],sent);
  s[t+1] = NULL;
  return(1);
}

int mapnumber(char *s)
{
  int retur;
  
  if (*s != '"') return(-1);
  s++;
  if ((*s!='#')||(s[1]<'0')||(s[1]>'9')||(s[2]<'0')||(s[2]>'9')
      ||(s[3]<'0')||(s[3]>'9')||(s[4]!='_')) return(-1);
  sscanf(&s[1],"%d",&retur);
  return(retur);
}

int find_files(char *dirname,char *match,int (*func)(char *,char *),char **files)
{
  DIR *dir;
  char *dirs[100],temp[500];
  struct direct *dp;
  struct stat *buf = new struct stat;
  int t=0,f=0;

  if (!(dir = opendir(dirname))) return(0);
  
  for (dp=readdir(dir);dp;dp=readdir(dir))
    if ( strcmp(dp->gd_name,".") && strcmp(dp->gd_name,"..") )
      {
	sprintf(temp,"%s/%s",dirname,dp->gd_name);
	lstat(temp,buf);
	if (buf->st_mode & S_IFDIR)
	  strcpy(dirs[t++] = new char[strlen(temp)+1],temp);
	else if ((buf->st_mode & S_IFREG) && (! (*func)(match,dp->gd_name)))
	  {
	    strcpy(files[f++] = new char[strlen(temp)+1],temp);
	    cout << "File " << files[f-1] << " matches " << match << "\n";
	  }
      }
  closedir(dir);
  
  for(;t;t--) 
    {
      f+=find_files(dirs[t-1],match,func,&files[f]);
      delete(dirs[t-1]);
    }
  return(f);
}

int main(int argc,char **argv)
{
  int t;
  char *s1,*s2,*buffer = new char[200];
  class mapping *maptab[1000];
  files int_files;
  
  if ( ((argc!=1)&&(int_files.init_files(argv[1])))
      && (int_files.init_files(".")) )
    {
      printf("Error finding files\n");
      return(0);
    }
  return(0);
}
