#ifdef include
extern int fprintf();
extern int fread();
extern int fwrite();
extern int fscanf();
extern void fclose();
extern int fgetc();
extern int fputc();
extern int printf();
#endif

#define RLK                     (1L << 0)
#define MYGETPUT		(1L << 1)
#define FSCANFPRINTF		(1L << 2)
#define FREADFWRITE             (1L << 3)

#define Fgetint(i,s,t)   for((i)=0,t=3;t>=0;t--) (i)+=(fgetc(s)<<(t*8))
#define Fputint(i,s,t)   for(t=3;t>=0;t--) fputc((char)(((i)>>(t*8))&255),s)

/* Loads a run-length encoded file and returns it in a char buffer */
char *load(FILE *from,int *x,int *y,long flags)
{
  int t,tot;
  unsigned char number;
  char *buffer,code;

  if (flags&MYGETPUT)
    {
      Fgetint(*x,from,t);
      Fgetint(*y,from,t);
    }

  if (flags&FSCANFPRINTF) fscanf(from,"%d %d",x,y);
    
  if (flags&FREADFWRITE) 
    {
      fread((char *)x,sizeof(*x),1,from);
      fread((char *)y,sizeof(*x),1,from);
    }
  
  buffer=(char *)malloc((*x)*(*y));
  t=0;
  tot=(*x)*(*y);
  
  if (!(flags&RLK)) 
    {
      fread(buffer,sizeof(char),tot,from);
      return(buffer);
    }
  
  do
    {
      fread((char *)&number,sizeof(number),1,from);
      fread((char *)&code,sizeof(code),1,from);
      for(;(number);number--) buffer[t++]=code;
      if(t<tot)
        {
          fread((char *)&number,sizeof(number),1,from);
          fread((char *)&buffer[t],sizeof(*buffer),(int)number,from);
          t+=(int)number;
        }
    }
  while(tot>t);
  if (tot!=t) fprintf(stderr,"Feil i innput from fil\n");
  fclose(from);
  return(buffer);
}

void save(FILE *to,char *buffer,int x,int y,long flags)
{
  int t,tot,max=255;
  unsigned char number;
  char code;

  if (flags&MYGETPUT)
    {
      Fputint(x,to,t);
      Fputint(y,to,t);
    }

  if (flags&FSCANFPRINTF) fprintf(to,"%d %d",x,y);
    
  if (flags&FREADFWRITE)
    {
      fwrite((char *)&x,sizeof(x),1,to);
      fwrite((char *)&y,sizeof(y),1,to);
    }
  
  t=0;
  tot=x*y;

  if (!(flags&RLK)) fwrite(buffer,sizeof(char),tot,to);
  else do
    {
      number=0;
      if (t+max>tot) max=tot-t;
      code=buffer[t];
      do
        number+=1;
      while((buffer[t+(int)number]==code)&&(number<max));
      fwrite((char *)&number,sizeof(number),1,to);
      fwrite((char *)&code,sizeof(code),1,to);
      t+=(int)number;
      
      if (t<tot)
        {
          number=0;
          if (t+max>tot) max=tot-t;
          do
            number+=1;
          while(buffer[t+(int)number-1]!=buffer[t+(int)number] && number!=255);
          fwrite((char *)&number,sizeof(number),1,to);
          fwrite((char *)&buffer[t],sizeof(*buffer),number,to);
          t+=(int)number;
        }
    }
  while(t<tot);
}
