#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <math.h> 
#include <malloc.h>
#include <errno.h>

#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>

#include "filtere.c"

int main(int argc,char **argv)
{
  Display *display;
  Visual *visual;
  Window parent,win;
  XImage *ximage;
  XSetWindowAttributes attribut;
  XSizeHints s_h;
  char win_name[100];
  unsigned long mask=0;
  GC gc;
  int scr;
  char *picture,host[100];
  int x,y;
  FILE *fd;
  
  if (argc!=4)
    {
      fprintf(stderr,"kikkbuffer filname server <8 16 32>\n");
      exit(0);
    }
  
  attribut.backing_store = Always;
  mask=CWBackingStore;
  
  fd=fopen(argv[1],"r");
  picture=load(fd,&x,&y,RLK|MYGETPUT);  
  fclose(fd);
  
  s_h.x = 0;
  s_h.y = 0;
  s_h.width = x;
  s_h.height = y;
  sprintf(win_name,"%s %dx%d %s",argv[3],x,y,argv[1]);
  sprintf(host,"%s:0.0",argv[2]);

  display=XOpenDisplay(host);
  scr=DefaultScreen(display);
  gc = DefaultGC(display,scr);
  visual = XDefaultVisual(display,scr);
  parent=RootWindow(display,scr);
  win=XCreateWindow(display,parent,0,0,x,y,0,0,
		    InputOutput,visual,mask,&attribut);
 
  XSetStandardProperties(display,win,win_name,NULL,NULL,argv,1,&s_h);
  XMapWindow(display,win);
  ximage=XCreateImage(display,visual,8,ZPixmap,0,picture,x,y,atoi(argv[3]),0);
  XPutImage(display,win,gc,ximage,0,0,0,0,x,y);
  XSync(display,True);
  XSelectInput(display,win,ButtonPressMask);
  while(!XPending(display));
  XDestroyWindow(display,win);
  XSync(display,True);
  XCloseDisplay(display);
  return(0);
}
