#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <math.h>
#include <malloc.h>
#include <errno.h>

#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>

#include "filtere.c"

int main(int argc,char **argv)
{
  Display *display;
  Visual *visual;
  Window parent,win;
  XImage *ximage;
  XSetWindowAttributes attribute;
  XSizeHints s_h;
  char win_name[100];
  unsigned long mask=0;
  GC gc;
  int scr;
  char *picture;
  int x,y;
  
  picture=load(stdin,&x,&y,RLK|MYGETPUT);  
  
  s_h.x = 0;
  s_h.y = 0;
  s_h.width = x;
  s_h.height = y;
  s_h.flags = PSize;
  
  if (argc==2) sprintf(win_name,"%s %dx%d",argv[1],x,y);
  else  sprintf(win_name,"%dx%d",x,y);

  display = XOpenDisplay(0);
  scr     = DefaultScreen(display);
  gc      = DefaultGC(display,scr);
  visual  = XDefaultVisual(display,scr);
  parent  = RootWindow(display,scr);

  attribute.backing_store     = Always;
  attribute.background_pixmap = ParentRelative;
  attribute.background_pixel  = WhitePixel(display,scr);
  mask                       = CWBackingStore | CWBackPixel | CWBackPixmap;
  
  win=XCreateWindow(display,parent,0,0,x*3,y*3,0,0,
		    InputOutput,visual,mask,&attribute);
 
  XSetStandardProperties(display,win,win_name,NULL,NULL,argv,1,&s_h);
  XMapWindow(display,win);
  ximage=XCreateImage(display,visual,8,ZPixmap,0,picture,x,y,8,0);
  XClearWindow(display,win);
  XClearWindow(display,win);
  XPutImage(display,win,gc,ximage,0,0,x,y,x,y);
  XSync(display,True);
  XSelectInput(display,win,ButtonPressMask);
  while(!XPending(display));
  XDestroyWindow(display,win);
  XSync(display,True);
  XCloseDisplay(display);
  return(0);
}
