#include <stdio.h>
#include <sys/types.h>
#include <sys/dir.h>
#include <sys/stat.h>
#include <string.h>
#include <stream.h>

int get_name_of_files(char **filelist,char *match);

class files
{
private:
  DIR *topdir;
  char *mapfile_n[1024];
  char *mapfiles_n[1024];
  char *datafiles_n[1024];
  char *xrasfiles_n[1024];
  char *programfiles_n[1024];
  int mapfiles_index;
  int datafiles_index;
  int xrasfiles_index;
  int programfiles_index;
public:
  int init_files();
};

int files::init_files()
{
  topdir = opendir(".");
//  mapfile_n = get_name_of_files("mapfile");
  mapfiles_n[0] = NULL;
  return(0);
}

class mapping
{
private:
  char *s[10];
  int oc;
public:
  mapping(char *sent ) 
    { strcpy(s[0] = new char[strlen(sent)+1],sent) ; s[1]=NULL ; oc = 1 ; }
  ~mapping() { for(int t=0;s[t];t++) delete(s[t]); }
  int cons_check(char *);
  void print()
    {
      cout << oc << ' ' ;
      for(int t=0; s[t] ; t++) cout << s[t];
      cout << '\n' ;
    }
};

int mapping::cons_check(char *sent)
{
  int t;
  oc++;
  for(t=0;s[t];t++) if (!strcmp(s[t],sent)) return(0);
  strcpy(s[t]=new char[strlen(sent)+1],sent);
  s[t+1] = NULL;
  return(1);
}

int mapnumber(char *s)
{
  int retur;
  
  if (*s != '"') return(-1);
  s++;
  if ((*s!='#')||(s[1]<'0')||(s[1]>'9')||(s[2]<'0')||(s[2]>'9')
      ||(s[3]<'0')||(s[3]>'9')||(s[4]!='_')) return(-1);
  sscanf(&s[1],"%d",&retur);
  return(retur);
}

int find_files(char *dirname,char *match,int (*func)(char *,char *),char **files)
{
  DIR *dir;
  char *dirs[100];
  struct direct *dp;
  struct stat *buf = new struct stat;
  int t=0,f=0;
  
  if (!(dir = opendir(dirname))) return(0);

  for (dp=readdir(dir);dp;dp=readdir(dir))
    if ( strcmp(dp->d_name,".") && strcmp(dp->d_name,"..") )
      {
	lstat(dp->d_name,buf);
	cout << dp->d_name << "\n" ;
	if (buf->st_mode & S_IFDIR)
	  {
	    dirs[t] = new char[strlen(dp->d_name)+strlen(dirname)+2];
	    sprintf(dirs[t++],"%s/%s",dirname,dp->d_name);
	  }
	if ((buf->st_mode & S_IFREG) && ((*func)(match,dp->d_name)))
	  {
	    files[f] = new char[strlen(dp->d_name)+strlen(dirname)+2];
	    sprintf(files[f++],"%s/%s",dirname,dp->d_name);
	  }
      }
  closedir(dir);
  
  for(;t;t--) 
    {
      f+=find_files(dirs[t-1],match,func,&files[f]);
      delete(dirs[t-1]);
    }
  return(f);
}

int main(int argc,char **argv)
{
  if ((argc!=1)&&((argc != 2) || (chdir(argv[1]))) )
    {
      cout << "Usage " << argv[0] << argc << " [directory]\n" ;
      exit(0);
    }

  int t;
  char *s1,*s2,*buffer = new char[200];
  class mapping *maptab[1000];
  
  for(t=0;t<1000;t++) maptab[t]=NULL;
  while(buffer = fgets(buffer,199,stdin))
    if ( (*buffer != '!') && (s1=strchr(buffer,'"')) && (s2=strchr(s1+1,'"')))
      {
	*(++s2) = 0;
	if ((t=mapnumber(s1)) != -1)
	  {
	    if (!maptab[t]) maptab[t] = new mapping(s1);
	    else            maptab[t]->cons_check(s1);
	  }
      }
  for(t=0;t<1000;t++) if (maptab[t]) maptab[t]->print();
  return(0);
}

