#include "xrisk.h"
#include "randomex.h"
#include "risklibex.h"
#include "xrisklibex.h"
#include "xriskex.h"

/* Give player a card */
cardp get_card()
{
  int   t;
  cardp retur;

  for(t=0;cards[t];t++);
  if (!t) risk_exit("To few cards in get_card\n",LAST_ARG);
  retur=cards[t-1];
  cards[t-1]=NULL;
  return(retur);
}

/* Get kard from player */
void deliver_card(card)
     cardp card;
{
  int t,t1;

  for(t=0;cards[t];t++);
  cards[t++] = card;
  if (t > NUM_CARDS) risk_exit("To many cards in deliver_card\n",LAST_ARG);
  cards[t] = NULL;
  t1       = Random(t);
  Switch(cards[t-1],cards[t1],card);
}

/* Remove a card from the list */
void sub_card(player,cardnr)
     playerp player;
     int cardnr;
{
  card_winp     cardwin;
  struct Card **card;

  cardwin = player->card_win;
  card    = player->card;
  
  XDestroyImage(cardwin->gimage[cardnr]);
  for(;card[cardnr] && cardnr+1 < CARDS_MAX_PLAYER;cardnr++)
    {
      card[cardnr]            = card[cardnr+1];
      cardwin->gimage[cardnr] = cardwin->gimage[cardnr+1];
    }
  if ((cardnr+1 == CARDS_MAX_PLAYER) && (card[cardnr])) risk_exit
    ("Non-null terminatet card-list for %s\n",player->name);
  update_infowin(player,-1,U_CARDS);
}

/* Give player a card */
void add_card(player, card)
     playerp player;
     cardp card;
{
  char         *temp;
  card_winp     cardwin;
  int           cardnr,t;
  xconp         xinfo;
    
  temp                   = (char *)malloc(BORDERX*BORDERY);
  xinfo                  = player->xcon;
  cardwin                = player->card_win;
  cardnr                 = player->num_cards;
  player->card[cardnr]   = card;
  player->card[cardnr+1] = NULL;
  
  for(t=0;t<BORDERX*BORDERY;t++)
    if (card->border[t]) temp[t] = (xinfo->white & 255);
    else                 temp[t] = (xinfo->black & 255);
  
  cardwin->gimage[cardnr] = XCreateImage
    (xinfo->disp,xinfo->visual,xinfo->depth,
     ZPixmap,0,temp,BORDERX,BORDERY,8,0);
  
  update_infowin(player,1,U_CARDS);
}

/* Show whether you have selected the card */
void show_chosen_card(xinfo, cardwin, t)
     xconp     xinfo;
     card_winp cardwin;
     int       t;
{
  if (Chosen(cardwin->chosen,t)) write_line
    (xinfo,cardwin->buttons[t],-1,-1,0,FILLH+FONTH,C_WIDTH,-1,
     cardwin->card[t]->unit,CLR|CENTER);
  else write_line
    (xinfo,cardwin->buttons[t],-1,-1,0,FILLH+FONTH,C_WIDTH,-1,"",CLR);
}

/* (Re)Draw a card */
void draw_chosen_card(player, xinfo, cardwin, t)
     playerp player;
     xconp xinfo;
     card_winp cardwin;
     int t;
{
  if (t < player->num_cards)
    {
      XPutImage(xinfo->disp,cardwin->cards[t],xinfo->gc,
		cardwin->aimage[cardwin->card[t]->indexunit],
		0,0,0,0,UNITX,UNITY);
      write_line(xinfo,cardwin->cards[t],-1,-1,0,UNITY+2*FILLH+FONTH,
		 C_WIDTH,-1,cardwin->card[t]->name,CLR|CENTER);
      XPutImage(xinfo->disp,cardwin->cards[t],xinfo->gc,cardwin->gimage[t],
		0,0,0,C_HEIGHT-BORDERY,BORDERX,BORDERY);
    }
  else
    {
      XSetForeground(xinfo->disp,xinfo->gc,xinfo->black);
      XFillRectangle(xinfo->disp,cardwin->cards[t],xinfo->gc,
		     0,0,C_WIDTH,C_HEIGHT);
    }
  show_chosen_card(xinfo,cardwin,t);
}

/* Redraw the card-window */
int update_cardwin(player)
     playerp player;
{
  int   t;
  
  if (!player->xcon) return(1);
  for(t=0;t<CARDS_MAX_SHOWN;t++)
    draw_chosen_card(player, player->xcon, player->card_win, t);
  return(0);
}

/* When we have to redraw sth. in the cardwin after an exposure-event */
int expose_card_button(player, number)
     playerp player;
     int number;
{
  if (number >= player->num_cards) return(1);
  show_chosen_card(player->xcon, player->card_win, number);
  return(0);
}

/* When we have to redraw sth. in the cardwin after an exposure-event */
int expose_card_win(player, number)
     playerp player;
     int number;
{
  if (number<CARDS_MAX_SHOWN)
    draw_chosen_card(player, player->xcon, player->card_win, number);
  return(0);
}

/* Transfer all cards from one player to another */
int transfer_all_cards(from, target)
     playerp from;
     playerp target;
{
  int   t;
  
  if ( !(t = from->num_cards) ) return(0);
  
  while(from->card[0])
    {
      add_card(target,from->card_win->card[0]);
      sub_card(from,0);
    }  
  if (t==1) write_msg_all_arg
    ("#028_Doing this %s gained %d new card",target->name,t,LAST_ARG);
  else write_msg_all_arg
    ("#029_Doing this %s gained %d new cards",target->name,t,LAST_ARG);

  target->card_win->chosen   = 0;
  from->card_win->chosen     = 0;
  target->card_win->exchange = 0;
  from->card_win->exchange   = 0;
  update_cardwin(target);
  update_cardwin(from);
  return(t);
}

/* Returns value of the cards you have chosen */
int value_of_card(cardwin)
     card_winp cardwin;
{
  int h=0,t;
  
  cardwin->exchange = 0;

  for(t=0;cardwin->card[t];t++) 
    if (Chosen(cardwin->chosen,t)) h+=cardwin->card[t]->value;

  if ( (h == 3*V_UNIT0) || (h == 2*V_UNIT0 + V_JOKER) ) cardwin->exchange =  4;
  if ( (h == 3*V_UNIT1) || (h == 2*V_UNIT1 + V_JOKER) ) cardwin->exchange =  6;
  if ( (h == 3*V_UNIT2) || (h == 2*V_UNIT2 + V_JOKER) ) cardwin->exchange =  8;
  if (   ( h == V_UNIT0 + V_UNIT1 + V_UNIT2  ) 
      || ( h == V_JOKER + V_UNIT1 + V_UNIT2  ) 
      || ( h == V_UNIT0 + V_JOKER + V_UNIT2  ) 
      || ( h == V_UNIT0 + V_UNIT1 + V_JOKER )
      || ( h == V_JOKER + V_JOKER + V_UNIT2  ) 
      || ( h == V_JOKER + V_UNIT1 + V_JOKER ) 
      || ( h == V_UNIT0 + V_JOKER + V_JOKER ) )       cardwin->exchange = 10;
  return(cardwin->exchange);
}

/* Remove all cards from a player */
void remove_all_cards_player(player)
     playerp player;
{
  struct Card **card;
  card_winp     cardwin;
  
  cardwin           = player->card_win;
  card              = cardwin->card;
  cardwin->chosen   = 0;
  cardwin->exchange = 0;
  while(card[0]) 
    {
      deliver_card(card[0]);
      sub_card(player,0);
    }
  update_cardwin(player);
}

/* Switch cards in the table */
void switch_card(cardwin, k1, k2)
     card_winp cardwin;
     int k1, k2;
{
  XImage *swimage;
  cardp   swcard;
  
  Switch(cardwin->gimage[k1],cardwin->gimage[k2],swimage);
  Switch(cardwin->card[k1]  ,cardwin->card[k2],swcard);
}

/* Give a player his card */
void give_player_card(player)
     playerp player;
{
  cardp card;

  card = get_card();
  add_card(player,card);
  update_cardwin(player);
}

/* change cards if it is egal */
int exchanges_cards(cardwin)
     card_winp cardwin;
{
  int           retur,t;
  struct Card **card;

  if (! (retur=value_of_card(cardwin)) ) return(0);

  card = cardwin->card;

  for(t=cardwin->player->num_cards-1;t>=0;t--) if (Chosen(cardwin->chosen,t))
    {
      if (card[t]->occupant==cardwin->player) 
	{
	  add_armies(card[t],2,UPDATE);
	  write_msg_all_arg("#009_%s gets 2 armies in %s",
				 cardwin->player->name,card[t]->name,LAST_ARG);
	}
      deliver_card(card[t]);
      sub_card(cardwin->player,t);
    }
  
  cardwin->chosen   = 0;
  cardwin->exchange = 0;
  update_cardwin(cardwin->player);
  write_msg_all_arg("#004_%s exchanged cards for %d armies",
			 cardwin->player->name,retur,LAST_ARG);
  return(retur);
}

/* change cards */
int exchange_card(player)
     playerp player;
{
  card_winp cardwin;
  
  cardwin                       = player->card_win;
  player->pstat->armies_left   += exchanges_cards(cardwin);
  if ((player->pstat->armies_max = player->pstat->armies_left))
    write_msg_arg(player,"#059_You have %d armies to place"
		  ,player->pstat->armies_left,LAST_ARG);  
  return(0);
}
