#include "xrisk.h"
#include "xriskex.h"
#include "risklibex.h"
#include "xrisklibex.h"
#include "control_states.h"

/* Control functions */

/* Someone fullfilled his mission */
int done_mission(player)
     playerp player;
{
  int t;
  
  write_msg(player,"#072_Congratulations, you have fullfilled your mission");
  write_msg_all_arg("#073_%s's mission was to :",player->name,LAST_ARG);
  write_msg_all(player->mission->sentence);
  write_msg_all("#074_This mission is now fullfilled");
  write_msg_all_arg
    ("#075_%s is the winner of xrisk",player->name,LAST_ARG);
  Do_each_player(t) if (players[t]->state->state < END_GAME)
    parse_killed(players[t]);
  return(0);
}

/* We have got a winner */
int a_winner()
{
  int t;
  Do_each_player(t) if (players[t]->state->state < END_GAME)
    {
      parse_killed(players[t]);
      write_msg(players[t],
		"#032_Congratulations, you have conquered the world");
      write_msg_all_arg("#008_%s conquered the world",
			players[t]->name,LAST_ARG);
    }
  return(0);
}

#define BitSet(a,b) ( ( (a) >> (b) ) & 1 )

/* Over to the next control_state */
int next_control_state()
{
  control_data.control_action = 
    &control_actions[control_data.control_action->index_next];
  control_data.who_where = &who_where[control_data.control_action->c_state];
  return(0);
}

/* Wait for all the others before continuing */
int wait_for_all()
{
  int i,c,next_state,players_in_state;
  
  if (num_players==1) a_winner();
  if (num_players < 2)
    {
      next_control_state();
      return(0);
    }

  i = *(control_data.who_where);
 
  for(c=0,players_in_state=0;c<16;c++) if (BitSet(i,c)) players_in_state++;
  
  if (players_in_state != num_players) return(0);
  
  next_state = control_data.control_action->next_state;
  for(c=0;c<16;c++) if (BitSet(i,c)) new_state(players[c],next_state);
  next_control_state();
  return(0);
}

/* Wait for your turn */
int wait_for_turn()
{
  int        i,c,next_state,players_in_state;
  static int which_player=0;
  
  if (num_players == 1) a_winner();
  if (num_players  < 2)
    {
      next_control_state();
      return(0);
    }

  i = *(control_data.who_where);
 
  for(c=0,players_in_state=0;c<16;c++) if (BitSet(i,c)) players_in_state++;
  
  if ((game_options.options & TWO_ACTIVE_PLAYERS) && (num_players > 2))
    { if (players_in_state < num_players-1 ) return(0); }
  else  
    { if (players_in_state != num_players)   return(0); }

  do
    if (which_player>MAX_PLAYERS) which_player=0;
    else                          which_player++;
  while(!BitSet(i,which_player));
  
  next_state = control_data.control_action->next_state;
  new_state(players[which_player],next_state);
  return(0);
}

/* Wait for all to quit */
int wait_all_quit()
{
  if (*control_data.who_where) return(0);
  next_control_state();
  return(0);
}

/* Wait for the players to close down */
int control_next()
{
  if (*control_data.who_where) return(0);
  return(1);
}
