#include "xrisk.h"
#include "xriskex.h"
#include "risklibex.h"
#include "xrisklibex.h"
#include "cursors.h"
#include "cardex.h"
#include "actions_menu_but.h"
#include "fontsex.h"

/* Initialze place-armies */
int p_a_where_init(player)
     playerp player;
{
  if (player->num_cards >= 5)
    {
      write_msg_arg(player, "#060_You have %d cards and have to exchange !!",
		    player->num_cards,LAST_ARG);
      return(0);
    }
  
  if (player->pstat->armies_left >= 2) write_msg_arg
    (player,"#058_You have %d armies left to place",
     player->pstat->armies_left,LAST_ARG);
  else write_msg(player,"#062_You have 1 army left to place");
  
  return(0);
}

/* Written when your not in turn */
int wait_msg(player)
     playerp player;
{
  write_msg(player,"#066_Wait for your turn");
  return(0);
}

/* What to do when a player press left button in the scroll-window */
int scroll_func(player)
     playerp player;
{
  if (player->state->all_actions->next_state != DUMMY_FUNC)
    new_state(player,player->state->all_actions->next_state);
  return(0);
}

/* Return 0 */
int none(player)
     playerp player;
{
  return(0);
}

/* Just testing */
int test(player)
     playerp player;
{
  return(0);
}

/* Jump to next function */
int next(player)
     playerp player;
{
  return(1);
}

/* Initialize find attacking land */
int f_a_where_init(player)
     playerp player;
{
  write_msg(player,"#025_Choose a country from which to attack");
  return(0);
}

/* We have allready allocated player, defined states 
   and distributed countries */
int init_player(player)
     playerp player;
{
  int t;
  
  for(t=0;t<MAX_PLAYERS;t++) player->colors[t] = &colors[t];
  
  player->card[0]             = NULL;
  player->offensiv            = 0;
  player->pstat               = (pstatp)malloc(sizeof(struct PStat));
  player->pstat->spec_win     = (Window)NULL;
  player->pstat->country      = (countryp)NULL;
  player->pstat->return_state = NUM_STATES;
  player->pstat->exit_press   = 0;
  *(player->pstat->string[1]  = (char *)malloc(MAXLEN_MISC+1)) = 0;
  *(player->pstat->string[2]  = (char *)malloc(MAXLEN_MISC+1)) = 0;
  player->attr.attr_game      = 0;
  player->attr.attack_armies  = 3;
  return(1);
}

/* Initialize mapwindow */
int init_mapwin(player)
     playerp player;
{
  int            t,bwidth=2;
  xconp          xinfo;
  XSizeHints     s_h;
  XGCValues      values;
  XVisualInfo    vinfo_return;
  char          *win_name,*name;
  char          *mmap;
  
  xinfo = (xconp)malloc(sizeof(struct Xcon));
  if (!(xinfo->disp=XOpenDisplay(player->client)))
    risk_exit("Could not open display %s\n",player->client,LAST_ARG);
  player->xcon                     = xinfo;
  xinfo->scr                       = DefaultScreen(xinfo->disp);
  xinfo->depth                     = DefaultDepth(xinfo->disp,xinfo->scr);
  xinfo->root                      = RootWindow(xinfo->disp,xinfo->scr);
  xinfo->screen                    = XScreenOfDisplay(xinfo->disp,xinfo->scr);
  xinfo->cmap                      = DefaultColormapOfScreen(xinfo->screen);
  xinfo->attr.backing_store        = Always;
  xinfo->attr.event_mask           = ButtonPressMask|KeyPressMask;
  xinfo->attrmask                  = CWBackingStore|CWEventMask;
  xinfo->indexs                    = player->indexs;
  xinfo->gc                        = DefaultGC(xinfo->disp,xinfo->scr);
  values.subwindow_mode = ClipByChildren;
  values.line_style     = LineSolid;
  values.line_width     = 1;
  values.fill_style     = FillSolid;
  XChangeGC(xinfo->disp, xinfo->gc,
	    GCSubwindowMode|GCLineStyle|GCLineWidth|GCFillStyle, &values);
  

  xinfo->visual = XDefaultVisual(xinfo->disp,xinfo->scr);
  if (xinfo->depth < 6 || !XMatchVisualInfo
      (xinfo->disp, xinfo->scr, xinfo->depth, PseudoColor, &vinfo_return))
    {
      xinfo->depth=32;
      do xinfo->depth--;
      while(xinfo->depth && !XMatchVisualInfo
	    (xinfo->disp,xinfo->scr,xinfo->depth,PseudoColor,&vinfo_return));
    }

  xinfo->visual = vinfo_return.visual;
  if (xinfo->depth < 6) risk_exit
    ("Could not get more than %d bitplanes on client %s, need 6\n"
     ,xinfo->depth, player->client);

  if (!DoesBackingStore(xinfo->screen)) xinfo->attr.event_mask |= ExposureMask;
  assign_font(player);

  for(t=0;t<NUMB_CURSORS;t++) 
    {
      if (cursor_table[t].index != t) risk_exit
	("Mistake in cursor_table[%d] in functions.h",t);
      xinfo->cursors[t] = XCreateFontCursor(xinfo->disp,cursor_table[t].shape);
    }
  mmap     = (char *)malloc(XSIZE*YSIZE*sizeof(char));
  win_name = (char*)(malloc(MAXLEN_MISC+1));
  name     = (char*)(malloc(MAXLEN_NMISC+1));
  gethostname(name,MAXLEN_NMISC);
  sprintf(win_name,"%s @ %s",mappet(WINNAME),name);
  
  s_h.x          = 0;
  s_h.y          = 0;
  s_h.width      = XSIZE;
  s_h.height     = YSIZE;
  s_h.max_width  = XSIZE;
  s_h.max_height = YSIZE;
  s_h.min_width  = XSIZE;
  s_h.min_height = YSIZE;
  s_h.flags      = PSize|PMinSize|PMaxSize;
  
  xinfo = player->xcon;
  
  xinfo->win = XCreateWindow
    (xinfo->disp,xinfo->root,s_h.x,s_h.y,s_h.width,s_h.height,bwidth,
     xinfo->depth,InputOutput,xinfo->visual,
     xinfo->attrmask,&(xinfo->attr));
  
  XSetStandardProperties
    (xinfo->disp,xinfo->win,win_name,win_name,None,NULL,0,&s_h);
  
  /* Allocat colormap */
  
  if (!XAllocColorCells
      (xinfo->disp,xinfo->cmap,False,0,0,xinfo->pixm,NUM_COLORS))
    {
      xinfo->cmap = XCreateColormap
	(xinfo->disp,xinfo->win,xinfo->visual,AllocNone);
      if (!XAllocColorCells
	  (xinfo->disp,xinfo->cmap,False,0,0,xinfo->pixm,NUM_COLORS)) risk_exit
	    ("Do not know how to allocate colors on client %s\n",player->client);
    }
  XSetWindowColormap(xinfo->disp,xinfo->win,xinfo->cmap);
  update_colors(player);
  XSetBackground(xinfo->disp,xinfo->gc,xinfo->black);
  for(t=0;t<YSIZE*XSIZE;t++) mmap[t]=xinfo->pixm[(int)map[t]];
  
  xinfo->ximage = XCreateImage(xinfo->disp,xinfo->visual,xinfo->depth,
			       ZPixmap,0,mmap,XSIZE,YSIZE,32,0);
  for(t=0;t<MENU_NUMB;t++) 
    {
      xinfo->menu_butt[t] = XCreateSimpleWindow
	(xinfo->disp,xinfo->win,(t/3)*MENU_B,(t%3)*MENU_H,
	 MENU_B-2,MENU_H-2,2,xinfo->white,xinfo->black);
      XSelectInput(xinfo->disp,xinfo->menu_butt[t],xinfo->attr.event_mask);
      XChangeWindowAttributes
	(xinfo->disp,xinfo->menu_butt[t],CWBackingStore,&(xinfo->attr));
      if (actions_menu_but[t].index != t) risk_exit
	("Wrong index in actions_menu_but[%d] in file actions_menu_but.h\n",t);
      do_action(player,&(actions_menu_but[t].button_actions.action_mB2));
    }
  xinfo->scrollwin = XCreateSimpleWindow
    (xinfo->disp,xinfo->win,SCWINX,SCWINY,SCWINL,SCWINH,SCWINR,
     xinfo->white,xinfo->black);
  XChangeWindowAttributes
    (xinfo->disp,xinfo->scrollwin,CWBackingStore,&(xinfo->attr));
  XSelectInput(xinfo->disp,xinfo->scrollwin,xinfo->attr.event_mask);
  return(1);
}

/* Set up the mapwindow on the screen */
int set_up_mapwin(player)
     playerp player;
{
  xconp xinfo;
  int   t;
  
  xinfo = player->xcon;
  XMapWindow(xinfo->disp,xinfo->win);
  XMapWindow(xinfo->disp,xinfo->scrollwin);
  for(t=0;t<MENU_NUMB;t++) XMapWindow(xinfo->disp,xinfo->menu_butt[t]);
  update_mapwin(player);
  XFlush(xinfo->disp);
  return(1);
}

/* We only have to create some images once */
void start_unit_image(player)
     playerp player;
{
  char      *temp,*temp1;
  xconp      xinfo;
  card_winp  cardwin;
  int        t,t1;
  
  xinfo   = player->xcon;
  cardwin = player->card_win;
  
  /* Pictures representing 3 units are read */
  for(t1=0;t1<3;t1++)
    {
      temp1 = unitp[t1];
      temp  = (char *)malloc(UNITX*UNITY);
      
      for(t=0;t<UNITX*UNITY;t++)
        if (temp1[t]) temp[t] = (xinfo->white & 255);
        else          temp[t] = (xinfo->black & 255);
      
      cardwin->aimage[t1]=XCreateImage(xinfo->disp,xinfo->visual,xinfo->depth,
				       ZPixmap,0,temp,UNITX,UNITY,8,0);
    }
}

/* Initialize cardwindow */
int init_cardwin(player)
     playerp player;
{
  card_winp   cardwin;
  xconp       xinfo;
  XSizeHints *s_h,*k_h[CARDS_MAX_SHOWN],*b_h[CARDS_MAX_SHOWN];
  int         t;
  
  s_h = (XSizeHints *)malloc(sizeof(XSizeHints));
  
  s_h->x      = 0;
  s_h->y      = 0;
  s_h->height = 5*C_SPACE+2*CF_BUTTONH+2*CF_HEIGHT;
  s_h->width  = 6*C_SPACE+5*CF_WIDTH;
  
  s_h->min_width  = s_h->width;
  s_h->max_width  = s_h->width;
  s_h->min_height = s_h->height;
  s_h->max_height = s_h->height;
  s_h->flags      = PSize|PMinSize|PMaxSize;  
  
  for(t=0;t<CARDS_MAX_SHOWN;t++)
    {
      k_h[t]=(XSizeHints *)malloc(sizeof(XSizeHints));
      b_h[t]=(XSizeHints *)malloc(sizeof(XSizeHints));
      
      k_h[t]->x      = C_SPACE+C_FRAME+(CF_WIDTH+C_SPACE)*(t%CARDS_ROW);
      k_h[t]->y      = 2*C_SPACE+CF_BUTTONH+C_FRAME+
	(C_SPACE+CF_HEIGHT)*(t/CARDS_ROW);
      k_h[t]->height = C_HEIGHT;
      k_h[t]->width  = C_WIDTH;
      k_h[t]->flags  = PPosition|PSize;
      
      b_h[t]->x      = k_h[t]->x;
      b_h[t]->y      = C_SPACE+C_FRAME+
	(CF_BUTTONH+2*CF_HEIGHT+3*C_SPACE)*(t/CARDS_ROW);
      b_h[t]->height = C_BUTTONH;
      b_h[t]->width  = C_BUTTONW;
      b_h[t]->flags  = PPosition|PSize;
    }
  
  cardwin            = (card_winp)malloc(sizeof(struct Card_Win));
  player->card_win   = cardwin;
  cardwin->player    = player;
  cardwin->card      = player->card;
  xinfo              = player->xcon;
  
  cardwin->attr.event_mask           = ButtonPressMask|KeyPressMask;
  cardwin->attr.backing_store        = Always;
  cardwin->attr.background_pixel     = xinfo->black;
  cardwin->attr.border_pixel         = xinfo->white;
  cardwin->attrmask                  = CWBackingStore|CWBackPixel;
  cardwin->attrmask                 |= CWBorderPixel|CWEventMask;
  cardwin->s_h                       = s_h;
  cardwin->chosen                    = 0;
  cardwin->exchange                  = 0;
  cardwin->allow_ch                  = 0;
  if (!DoesBackingStore(xinfo->screen))
    cardwin->attr.event_mask        |= ExposureMask;
  
  start_unit_image(player);
  
  cardwin->win=XCreateWindow
    (xinfo->disp,xinfo->root,s_h->x,s_h->y,s_h->width,s_h->height,1,
     xinfo->depth,InputOutput,xinfo->visual,
     cardwin->attrmask,&(cardwin->attr));
  
  XSetWindowColormap(xinfo->disp,cardwin->win,xinfo->cmap);
  
  XSetStandardProperties
    (xinfo->disp,cardwin->win,mappet(CARD_WIN_NAME),
     mappet(CARD_WIN_NAME),None,(char**)NULL,(int)0,s_h);
  
  for(t=0;t<CARDS_MAX_SHOWN;t++)
    {
      cardwin->k_h[t] = k_h[t];
      cardwin->b_h[t] = b_h[t];
      
      cardwin->cards[t]  = XCreateSimpleWindow
	(xinfo->disp,cardwin->win,
	 k_h[t]->x,k_h[t]->y,k_h[t]->width,k_h[t]->height,1,
	 xinfo->white,xinfo->black);
      cardwin->buttons[t] = XCreateSimpleWindow
	(xinfo->disp,cardwin->win,
	 b_h[t]->x,b_h[t]->y,b_h[t]->width,b_h[t]->height,1,
	 xinfo->white,xinfo->black);
      
      XChangeWindowAttributes(xinfo->disp,cardwin->cards[t],
			      CWBackingStore,&(cardwin->attr));
      XChangeWindowAttributes(xinfo->disp,cardwin->buttons[t],
			      CWBackingStore,&(cardwin->attr));
      XSelectInput(xinfo->disp, cardwin->cards[t], 
		   cardwin->attr.event_mask & ExposureMask);
      XSelectInput(xinfo->disp, cardwin->buttons[t], 
		   cardwin->attr.event_mask & ExposureMask);
    }
  return(1);
}

/* Map the cardwin on screen */
int set_up_cardwin(player)
     playerp player;
{
  int        t;
  xconp      xinfo;
  card_winp  cardwin;
  
  xinfo   = player->xcon;
  cardwin = player->card_win;
  
  XMapWindow(xinfo->disp,cardwin->win);
  for(t=0;t<CARDS_MAX_SHOWN;t++)
    {
      XMapWindow(xinfo->disp,cardwin->cards[t]);
      XMapWindow(xinfo->disp,cardwin->buttons[t]);
    }
  return(1);
}

/* Initialize the info-window */
int init_infowin(player)
     playerp player;
{
  int         t;
  info_winp   infowin;
  xconp       xinfo;
  XSizeHints *s_h,*u_h,*l_h;
  XWMHints   *wmh;
  
  u_h              = (XSizeHints *)malloc(sizeof(XSizeHints));
  l_h              = (XSizeHints *)malloc(sizeof(XSizeHints));
  s_h              = (XSizeHints *)malloc(sizeof(XSizeHints));
  
  u_h->width       = HEIGHT_ROWS*MAX_PLAYERS+SPACE;
  l_h->width       = u_h->width;
  s_h->width       = u_h->width+2;
  u_h->height      = HEIGHT_ROWS+SPACE;
  l_h->height      = HEIGHT_ROWS*num_players+SPACE;
  s_h->height      = u_h->height+l_h->height+4;
  
  s_h->min_width   = s_h->width;
  s_h->max_width   = s_h->width;
  s_h->min_height  = s_h->height;
  s_h->max_height  = s_h->height;
  
  s_h->x           = 0;
  s_h->y           = 0;
  u_h->x           = 0;
  u_h->y           = 0;
  l_h->x           = 0;
  l_h->y           = u_h->height+2;
  
  s_h->flags       = PSize|PMinSize|PMaxSize;
  u_h->flags       = PPosition|PSize;
  l_h->flags       = u_h->flags;
  
  wmh          = XAllocWMHints();
  wmh->input   = True;
  wmh->flags   = InputHint;
  
  infowin          = (info_winp)malloc(sizeof(struct Info_Win));
  player->info_win = infowin;
  xinfo            = player->xcon;
  
  infowin->attr.event_mask       = ButtonPressMask|KeyPressMask;
  infowin->attr.backing_store    = Always;
  infowin->attr.background_pixel = xinfo->black;
  infowin->attr.border_pixel     = xinfo->white;
  infowin->attrmask              = CWBackingStore|CWBackPixel;
  infowin->attrmask             |= CWBorderPixel;
  infowin->s_h                   = s_h;
  infowin->u_h                   = u_h;
  infowin->l_h                   = l_h;
  infowin->wmh                   = wmh;
  
  if (!DoesBackingStore(xinfo->screen))
    infowin->attr.event_mask |= ExposureMask;
  
  infowin->win=XCreateWindow
    (xinfo->disp,xinfo->root,s_h->x,s_h->y,s_h->width,s_h->height,1,
     xinfo->depth,InputOutput,xinfo->visual,
     infowin->attrmask,&(xinfo->attr));
  
  XSetWindowColormap(xinfo->disp,infowin->win,xinfo->cmap);
  
  XSetStandardProperties
    (xinfo->disp,infowin->win,mappet(INFO_WIN_NAME),
     mappet(INFO_WIN_NAME),None,(char **)NULL,(int)0,s_h);
  XSetWMHints(player->xcon->disp, player->info_win->win, infowin->wmh);
  
  infowin->upper=XCreateSimpleWindow
    (xinfo->disp,infowin->win,u_h->x,u_h->y,u_h->width,u_h->height,1,
     xinfo->white,xinfo->black);
  infowin->lower=XCreateSimpleWindow
    (xinfo->disp,infowin->win,l_h->x,l_h->y,l_h->width,l_h->height,1,
     xinfo->white,xinfo->black);
  
  XSetWindowColormap(xinfo->disp,infowin->win,xinfo->cmap);
  XSetWindowColormap(xinfo->disp,infowin->upper,xinfo->cmap);
  XSetWindowColormap(xinfo->disp,infowin->lower,xinfo->cmap);
  
  XChangeWindowAttributes
    (xinfo->disp,infowin->upper,CWBackingStore,&(infowin->attr));
  XChangeWindowAttributes
    (xinfo->disp,infowin->lower,CWBackingStore,&(infowin->attr));
  
  for(t=0;t<MAX_PLAYERS;t++) infowin->child[t]=XCreateSimpleWindow
    (xinfo->disp,infowin->upper,t*(SPACE+2*FRAME+WIDTH_BUTT)+SPACE,
     SPACE,WIDTH_BUTT,WIDTH_BUTT,FRAME,xinfo->white,xinfo->pixm[t+50]);
  XFlush(xinfo->disp);
  
  /* Used after player has chosen color and name */
  u_h->width     = WIDTH_COL*NUM_COL+WIDTH_BUTT+2*(FRAME+SPACE);
  l_h->width     = u_h->width;
  s_h->width     = u_h->width+2;
  s_h->min_width = s_h->width;
  s_h->max_width = s_h->width;
  return(0);
}

int set_up_infowin(player)
     playerp player;
{
  int        t;
  xconp      xinfo;
  info_winp  infowin;
  
  xinfo   = player->xcon;
  infowin = player->info_win;
  
  XMapWindow(xinfo->disp,infowin->win);
  XMapWindow(xinfo->disp,infowin->upper);
  XMapWindow(xinfo->disp,infowin->lower);
  for(t=0;t<MAX_PLAYERS;t++) XMapWindow(xinfo->disp,infowin->child[t]); 
  return(1);
}

int get_col_init(player)
     playerp player;
{
  player->pstat->spec_win = player->info_win->upper;
  XSelectInput(player->xcon->disp, player->info_win->upper,
	       player->info_win->attr.event_mask);
  return(0);
}

int get_col_exit(player)
     playerp player;
{
  player->pstat->spec_win = (Window)NULL;
  XSelectInput(player->xcon->disp,player->info_win->upper, 
	       player->info_win->attr.event_mask & ExposureMask);
  XSelectInput(player->xcon->disp,player->info_win->lower, 
	       player->info_win->attr.event_mask & ExposureMask);
  return(0);
}

/* Get the color a player wants */
int get_col_equal(player)
     playerp player;
{
  xconp       xinfo;
  XEvent     *evp;
  info_winp   infowin;
  int         t,chosen;
  static int  totchosen=0;
  
  xinfo   = player->xcon;
  infowin = player->info_win;
  evp     = GetEventp(player);
  
  for(chosen=0;(infowin->child[chosen]!=evp->xbutton.subwindow)
      &&(chosen<MAX_PLAYERS);chosen++);
  if (chosen==MAX_PLAYERS) return(0);
  Choose(totchosen,chosen);
  
  XSetNormalHints(xinfo->disp,infowin->win,infowin->s_h);
  XSetNormalHints(xinfo->disp,infowin->upper,infowin->u_h);
  XSetNormalHints(xinfo->disp,infowin->lower,infowin->l_h);
  
  XResizeWindow
    (xinfo->disp,infowin->win,infowin->s_h->width,infowin->s_h->height);
  XResizeWindow
    (xinfo->disp,infowin->upper,infowin->u_h->width,infowin->u_h->height);
  XResizeWindow
    (xinfo->disp,infowin->lower,infowin->l_h->width,infowin->l_h->height);
  
  settopp_infowin(player);
  player->colors[player->indexs]=player->colors[chosen];
  
  for(t=0;t<MAX_PLAYERS;t++) if (!Chosen(totchosen,t))
    XDestroyWindow(xinfo->disp,infowin->child[t]);
  infowin->button=XCreateSimpleWindow
    (xinfo->disp,infowin->upper,SPACE,SPACE,WIDTH_BUTT,WIDTH_BUTT,FRAME,
     xinfo->white,xinfo->pixm[50+chosen]);
  
  XMapWindow(xinfo->disp,infowin->button);
  XFlush(xinfo->disp);
  
  Do_each_player(t)
    {
      xinfo   = players[t]->xcon;
      infowin = players[t]->info_win;
      if (players[t]->state->state <= PRESS_BUTTON) 
	XDestroyWindow(xinfo->disp,infowin->child[chosen]);
      infowin->child[chosen]=XCreateSimpleWindow
	(xinfo->disp,infowin->lower,SPACE,
	 SPACE+player->indexs*(SPACE+2*FRAME+WIDTH_BUTT), WIDTH_BUTT,
	 WIDTH_BUTT,FRAME,xinfo->white,xinfo->pixm[50+chosen]);
      XMapWindow(xinfo->disp,infowin->child[chosen]);
      XFlush(xinfo->disp);
    }
  return(1);
}

/* Initialize the action of getting a name */
int get_name_init(player)
     playerp player;
{
  pstatp  pstat;
  
  pstat                      = player->pstat;
  pstat->string[0]           = player->name;
  pstat->strlen              = strlen(player->name);
  pstat->win                 = player->info_win->lower;
  pstat->spec_win            = player->info_win->win;
  pstat->flags               = CENTER|CLR;
  pstat->clear_field         = 0;
  pstat->fc                  = player->xcon->white;
  pstat->bc                  = player->xcon->black;
  pstat->x                   = START_TEXT_X;
  pstat->y                   = START_TEXT_Y + player->indexs * HEIGHT_ROWS;
  pstat->dx                  = DX_KOL;
  pstat->dy                  = -1;
  pstat->strmax              = MAXLEN_NPLAYER;
  pstat->strmin              = MINLEN_NPLAYER;
  XSelectInput(player->xcon->disp,player->info_win->win,
	       player->info_win->attr.event_mask);
  return(0);
}

int get_name_exit(player)
     playerp player;
{
  player->pstat->spec_win = (Window)0;
  return(0);
}

/* Get a string from aa window */
int get_string(player)
     playerp player;
{
  XEvent        *pev;
  int            length;
  KeySym         tegn;
  XComposeStatus compose;
  pstatp         pstat;
  char          *string;
  char           buffer[10];
  xconp          xinfo;
  
  pstat  = player->pstat;
  pev    = GetEventp(player);
  length = pstat->strlen;
  string = pstat->string[0];
  xinfo  = player->xcon;
  
  XLookupString(&(pev->xkey),buffer,10,&tegn,&compose);
  if ( ((tegn==XK_Return)||(tegn==XK_Linefeed))
      && (length>=player->pstat->strmin))
    {
      if (player->pstat->clear_field) write_line
	(xinfo,player->pstat->win,player->pstat->fc,
	 player->pstat->bc,player->pstat->x,player->pstat->y,
	 player->pstat->dx,player->pstat->dy,"",player->pstat->flags);
      return(1);
    }
  
  if ((tegn>=XK_space)&&(tegn<=XK_asciitilde))
    if(length!=player->pstat->strmax) string[length++]=buffer[0];
  
  if ((tegn==XK_Delete)||(tegn==XK_BackSpace))
    if (length) length--;
  
  string[length] = 0;
  pstat->strlen  = length;
  
  write_line(xinfo,player->pstat->win,player->pstat->fc,
	     player->pstat->bc,player->pstat->x,player->pstat->y,
	     player->pstat->dx,player->pstat->dy,string,player->pstat->flags);
  return(0);
}

/* Clear the place where player-messages appear */
int clear_string(player)
     playerp player;
{
  write_line(player->xcon,player->pstat->win,player->pstat->fc,
	     player->pstat->bc,player->pstat->x,player->pstat->y,
	     player->pstat->dx,player->pstat->dy,"",player->pstat->flags);
  return(0);
}

/* Don't let to players have the same name */
int check_name(player)
     playerp player;
{
  int t;
  char *s;
  for(s=player->name;isspace(*s);s++);
  for(t=0;(player->name[t]= *s);t++,s++);
  if (t) for(s= &player->name[t-1];isspace(*s)&&s!=player->name;*(s--)=0);
  if (strlen(player->name) < MINLEN_NPLAYER)    return(1);
  Do_each_player(t) if(players[t]->state->state > CHECK_NAME)
    if (!strcmp(player->name,players[t]->name)) return(1);
  return(0);
}

/* Let all who have chosen their color know your name */
int export_name(player)
     playerp player;
{
  int        t,i;
  xconp      xinfo;
  info_winp  infowin;
  
  i = player->indexs;
  Do_each_player(t) if(players[t]->state->state > PRESS_BUTTON )
    {
      xinfo   = players[t]->xcon;
      infowin = players[t]->info_win;
      write_line(xinfo,infowin->lower,-1,-1,START_TEXT_X,
		 START_TEXT_Y+i*HEIGHT_ROWS,DX_KOL,-1,player->name,CENTER|CLR);
    }
  return(1);
}

/* Some fixing now that we know the players name */
int mission_fix(player)
     playerp player;
{
  if ((player->mission)&&(player->mission->victim)) sprintf
    (player->mission->sentence,mappet("#095_Kill %s"),
     player->mission->victim->name);
  return(0);
}

/* Initialize the statistics */
int init_pl_stat(player)
     playerp player;
{
  int t,country,armies,continenter;
  
  for(country=0,armies=0;player->conquests[country];country++)
    armies+=player->conquests[country]->number;
  for(t=0,continenter=0;t<NUM_CONTINENTS;t++)
    if (conquered_continent(player,&continents[t])) continenter++;
  
  player->num_conquests     = 0;
  player->num_continents    = 0;
  player->num_armies        = 0;
  player->num_armies_gained = 0;
  player->num_cards         = 0;
  player->armies_lost       = 0;
  player->armies_killed     = 0;
  
  update_infowin(player,country    ,U_COUNTRIES);
  update_infowin(player,continenter,U_CONTINENTS);
  update_infowin(player,armies     ,U_ARMIES);
  update_infowin(player,armies     ,U_ARMIES_GAINED);
  update_infowin(player,0          ,U_CARDS);
  update_infowin(player,0          ,U_ARMIES_LOST);
  update_infowin(player,0          ,U_ARMIES_KILLED);
  return(1);
}

/* Initialise the first setting of armies */
int i_init_armies(player)
     playerp player;
{
  pstatp pstat;
  
  pstat              = player->pstat;
  pstat->armies_left = game_options.armies_start;
  pstat->strmax      = 1;
  pstat->strmin      = 1;
  pstat->from        = (countryp)NULL;
  pstat->target      = (countryp)NULL;
  write_msg_arg(player,"#059_You have %d armies to place",
		ARMIES_START,LAST_ARG);  
  return(1);
}

/* Initialize free moves */
int free_move_init(player)
     playerp player;
{
  pstatp pstat;
  pstat              = player->pstat;
  pstat->armies_left = FREE_MOVES;
  pstat->strmax      = 10;
  pstat->strmin      = 1;
  pstat->from        = (countryp)NULL;
  pstat->target      = (countryp)NULL;
  write_msg(player,"");
  if (!op_move_armies(player)) return(2);
  return(1);
}

/* Tell player how many free moves he has got left */
int free_move_left(player)
     playerp player;
{
  if (player->pstat->armies_left)
    write_msg_arg(player,"#067_You have %d free moves",
		  player->pstat->armies_left,LAST_ARG);
  else return(1);
  return(0);
}

/* Where to place your first armies */
int i_a_where(player)
     playerp player;
{
  if ( !(player->pstat->country) || (player->pstat->country->occupant!=player) 
      || (player->pstat->country->number >= game_options.max_armies_start ))
    {
      if(player->pstat->country) 
	write_msg_arg(player,"#056_You can not place armies in %s"
		      ,player->pstat->country->name);
      return(0);
    }
  
  player->pstat->target     = player->pstat->country;
  player->pstat->from       = (countryp)NULL;
  player->pstat->armies_min = 0;
  player->pstat->armies_max = Min
    (player->pstat->armies_left,
     game_options.max_armies_start - player->pstat->target->number);
  return(1);
}

/* Update every player's color-table (Only done once) */
int fix_colors(player)
     playerp player;
{
  int t;
  
  Do_each_player(t) player->colors[t]=players[t]->colors[t];
  return(0);
}

/* Check where your pointer are */
int update_pointer(player)
     playerp player;
{
  Window       rr,cr;
  int          xr,yr,x,y;
  unsigned int mr;
  xconp        xinfo;
  
  xinfo=player->xcon;
  if(XQueryPointer(xinfo->disp,xinfo->win,&rr,&cr,&xr,&yr,&x,&y,&mr))
    player->pstat->country = find_country_coord(x,y);
  else player->pstat->country = NULL;
  
  if (xinfo->win) write_country(xinfo,player->pstat->country);
  return(0);
}

/* Initialize a new turn. Maybe even give you a hint */
int init_turn(player)
     playerp player;
{
  
  int nye=0;
  
  nye                        += new_armies(player);
  player->pstat->armies_left  = nye;
  player->offensiv            = 0;
  player->card_win->allow_ch  = 1;
  XBell(player->xcon->disp,100);
  XBell(player->xcon->disp,100);
  XBell(player->xcon->disp,100);
  write_msg_all_arg("#003_%s begins their turn with %d armies",
		    player->name,nye,LAST_ARG);
  exchange_card(player);
  return(1);
}

/* No more changing of cards */
int disable_ca_ch(player)
     playerp player;
{
  if (player->pstat->armies_left) return(0);
  player->card_win->allow_ch = 0;
  return(0);
}

/* Where to place armies */
int p_a_where(player)
     playerp player;
{
  if (!(player->pstat->country) || (player->pstat->country->occupant != player)
      || (!player->pstat->armies_left)) return(0);
  
  player->pstat->target     = player->pstat->country;
  player->pstat->from       = (countryp)NULL;
  player->pstat->armies_min = 0;
  player->pstat->armies_max = player->pstat->armies_left;
  
  if (player->pstat->armies_left == 1) 
    {
      player->pstat->armies_move = 1;
      return(2);
    }
  return(1);
}

/* Where to attack from */
int f_a_where(player)
     playerp player;
{
  if ( !(player->pstat->country)||(player->pstat->country->occupant != player)
      ||(player->pstat->country->number == 1) )
    {
      if (player->pstat->country) 
	write_msg_arg(player,"#052_You can not attack from %s !!",
		      player->pstat->country->name,LAST_ARG);
      return(0);
    }
  
  player->pstat->from = player->pstat->country;
  write_msg_arg(player,"#051_You attack from %s",
		player->pstat->country->name,LAST_ARG);
  write_msg_all_arg("#002_%s attacks from %s",player->name,
		    player->pstat->country->name,LAST_ARG);
  return(1);
}

/* Where to "free-move" from */
int f_m_where(player)
     playerp player;
{
  if ( !(player->pstat->country) || (player->pstat->country->occupant!=player)
      ||(player->pstat->country->number == 1)) 
    {
      if (player->pstat->country)
	write_msg_arg(player,"#054_You can not move any armies from %s !!",
		      player->pstat->country->name,LAST_ARG);
      return(0);
    }
  
  player->pstat->from       = player->pstat->country;
  player->pstat->armies_min = 0;
  player->pstat->armies_max = Min(player->pstat->from->number-1
				  ,player->pstat->armies_left);
  write_msg_arg(player,"#064_You move your armies from %s",
		player->pstat->country->name,LAST_ARG);
  return(1);
}

/* Place/move your armies */
int p_a_place(player)
     playerp player;
{
  if (   (player->pstat->from && player->pstat->from->occupant != player) 
      || player->pstat->target->occupant != player) return(1);
  
  move_armies(player->pstat->from,player->pstat->target,
	      player->pstat->armies_move);
  
  if ( !player->pstat->armies_left 
      ||(player->pstat->armies_left -= player->pstat->armies_move) ) return(1);
  
  if (!player->pstat->from) 
    write_msg(player,"#065_Your last army has been placed");
  return(2);
}

/* Mouse-button1 is supposed to return max */
int number_m1(player)
     playerp player;
{
  player->pstat->armies_move = player->pstat->armies_max;
  return(1);
}

/* Mouse-button2 returns 1 or min */
int number_m2(player)
     playerp player;
{
  player->pstat->armies_move = 
    Min(player->pstat->armies_max,Max(player->pstat->armies_min,1));
  return(1);
}

/* And mouse-botton3 will return min */
int number_m3(player)
     playerp player;
{
  if ((player->pstat->armies_move = player->pstat->armies_min)) return(1);
  return(2);
}

/* End of a turn */
int end_turn(player)
     playerp player;
{
  if (player->offensiv) give_player_card(player);
  write_msg(player,"");
  return(1);
}

/* Free moves to where ?? */
int free_move_to(player)
     playerp player;
{
  if (   (!player->pstat->country) 
      || (!neighbours(player->pstat->from,player->pstat->country))
      || (player->pstat->country->occupant!=player)
      || (player->pstat->from->occupant   !=player) )
    {
      if (player->pstat->target) write_msg_arg
	(player,"#055_You can not move any armies from %s to %s !!"
	 ,player->pstat->from->name,player->pstat->target->name,LAST_ARG);
      return(0);
    }
  player->pstat->target = player->pstat->country;
  return(1);
}

/* Attack a country */
int attack_country(player)
     playerp player;
{
  countryp from,target;
  int      minmove;
  
  target = player->pstat->country;
  from   = player->pstat->from;
  
  if ( (!target) || (!neighbours(from,target)) || target->occupant==player )
    return(0);
  
  if ( from->occupant!=player || from->number==1 ) 
    return(1);
  
  player->pstat->target = target;
  write_msg_arg(player,"#050_You attack from %s to %s",
		from->name,target->name,LAST_ARG);
  write_msg_all_arg("#001_%s attacks from %s to %s",
		    player->name,from->name,target->name,LAST_ARG);
  
  minmove = attack(from,target);
  if (!target->number)
    {
      player->offensiv++;
      if (minmove==1) write_msg_all_arg
	("#007_%s conquered %s with 1 army",
	 player->name,target->name,LAST_ARG);
      else write_msg_all_arg
	("#006_%s conquered %s with %d armies",
	 player->name,target->name,minmove,LAST_ARG);
      
      sub_country(target->occupant->conquests,target);
      if (!target->occupant->conquests[0])
	player_killed(from->occupant,target->occupant);
      
      target->occupant=from->occupant;
      set_color((playerp)NULL,target);
      add_country(from->occupant->conquests,target);
      
      sub_armies(from,NULL,minmove,NO_UPDATE);
      add_armies(target,minmove,NO_UPDATE);
      
      player->pstat->armies_min  = 0;
      player->pstat->armies_left = 0;
      player->pstat->armies_max  = from->number-1;
      
      if (from->number > 1) return(2);
      return(1);
    }
  if (from->number == 1) return(1);
  return(0);
}

/* Initialize to get a number when moving armies */
int p_a_get_num_i(player)
     playerp player;
{
  pstatp pstat;
  
  pstat                      = player->pstat;
  pstat->string[0]           = pstat->genstring;
  pstat->strlen              = 0;
  pstat->win                 = player->xcon->win;
  pstat->flags               = CENTER|CLR;
  pstat->fc                  = -1;
  pstat->bc                  = -1;
  pstat->x                   = MSGX;
  pstat->y                   = MSGY+20;
  pstat->dx                  = MSGLEN;
  pstat->dy                  = -1;
  pstat->strmax              = 30;
  pstat->strmin              = 1;
  pstat->clear_field         = 1;
  
  if (player->pstat->from) write_msg_arg
    (player,
     "#034_How many armies do you want to move from %s to %s (%d - %d)?",
     player->pstat->from->name,player->pstat->target->name,
     player->pstat->armies_min,player->pstat->armies_max,LAST_ARG);
  else write_msg_arg
    (player,
     "#035_How many armies do you want to place in %s (%d - %d)?",
     player->pstat->target->name,
     player->pstat->armies_min,player->pstat->armies_max,LAST_ARG);
  return(0);
}

/* Is this a number we can accept ?? */
int p_a_number(player)
     playerp player;
{
  player->pstat->armies_move = atoi(player->pstat->genstring);
  if (  (player->pstat->armies_move > player->pstat->armies_max)
      ||(player->pstat->armies_move < player->pstat->armies_min))
    return(2);
  return(1);
}

/* What to do when we choose a card */
int card_handler(player)
     playerp player;
{
  int        t;
  xconp      xinfo;
  card_winp  cardwin;
  XEvent    *eventp;
  
  xinfo   = player->xcon;
  cardwin = player->card_win;
  eventp  = GetEventp(player);
  
  for(t=0;((cardwin->card[t])&&(eventp->xbutton.subwindow!=cardwin->cards[t])
           &&(eventp->xbutton.subwindow!=cardwin->buttons[t]));t++);
  if ((t==CARDS_MAX_SHOWN)||(!cardwin->card[t])) return(0);
  
  Choose(cardwin->chosen,t);
  show_chosen_card(xinfo,cardwin,t);
  value_of_card(cardwin);
  if (cardwin->allow_ch == 1) exchange_card(player);
  if ((cardwin->allow_ch == 2)&&(cardwin->player->num_cards>=5))
    exchange_card(player);
  return(0);
}

/* End of game */
int end_game(player)
     playerp player;
{
  write_msg(player,"");
  return(0);
}

/* Really end of game */
int close_game(player)
     playerp player;
{
  free_player(player);
  return(0);
}      
