#include "xrisk.h"
#include "functions.h"
#include "functionsex.h"
#include "randomex.h"
#include "risklibex.h"
#include "xrisklibex.h"
#include "cursors2.h"
#include "control_states.h"
 
/* Give every player his mision */
void distribute_mission()
{
  int             ant,t;
  
  for(ant=0;missions[ant];ant++);
  Do_each_player(t)
    {
      missions[ant]              = (missionp)malloc(sizeof(struct Mission));
      missions[ant]->victim      = players[t];
      missions[ant]->conquestscont  = NULL;
      missions[ant]->conquestsc  = 0;
      missions[ant]->army        = 0;
      missions[ant]->sentence[0] = 0;
      ant++;
    }
  missions[ant]                  = NULL;
  if (game_options.options & MISSION) 
    {
      Do_each_player(t) players[t]->mission = get_mission(players[t]);
    }
  else Do_each_player(t) players[t]->mission = (missionp) NULL;
}

/* Initialize players and set state */
void init_players(mach)
     char **mach;
{
  int   t,r;
  char *sw;
  
  for(t=0;t<num_players;t++)
    {
      r=Random(num_players);
      Switch(mach[t],mach[r],sw);
    }
  for(t=0;t<MAX_PLAYERS;t++) if (t<num_players)
    {
      players[t]                = (playerp)malloc(sizeof(struct Player));
      if (strchr(mach[t],':'))    sprintf(players[t]->client,"%s",mach[t]);
      else                        sprintf(players[t]->client,"%s:0.0",mach[t]);
      players[t]->state         = states[FIRST_STATE];
      (who_where[FIRST_STATE]) ^= (1<<t);
      players[t]->indexs        = t;
      players[t]->xcon          = NULL;
      players[t]->name[0]       = 0;
    }
  else players[t] = (playerp)NULL;
}

/* Clean all countries */
void init_countries()
{
  int t;
  for(t=0;t<NUM_COUNTRIES;t++)
    {
      countries[t].occupant = NULL;
      countries[t].number   = 1;
    }
}

/* Initialize all states */
int init_states()
{
  int t;
  
  for(t=0;t<CONTROL_STATES;t++) if (control_actions[t].index != t) risk_exit
    ("Mistake in control_actions[%d] in functions.h\n",t,LAST_ARG);
  
  for(t=0;t<WINDOW_ACTIONS;t++) if (actions_other_win[t].index != t)
    risk_exit("Mistake in actions_other_win[%d] in functions.h\n",t,LAST_ARG);

  control_data.control_action = &control_actions[0];
  control_data.who_where      = &who_where[control_actions[0].c_state];
  
  for(t=0;t<NUM_STATES;t++)
    {
      who_where[t]=0;
      
      if (all_actions[t].state != t) risk_exit
	("Mistake in all_actions[%d] in functions.h\n",t,LAST_ARG);

      if (all_cursors[t].state != t) risk_exit
	("Mistake in all_cursors[%d] in functions.h\n",t,LAST_ARG);

      states[t]                    = (statep)malloc(sizeof(struct State));
      states[t]->state             = t;
      states[t]->all_actions       = &(all_actions[t]);
      states[t]->actions_other_win = actions_other_win;
      states[t]->who_where         = &who_where[t];
    }
  return(0);
}

/* Shuffle cards with or without joker */
void find_shuffle_cards(joker)
     int joker;
{
  int   t,t1,r;
  cardp sw;
  
  for(t=0;t<NUM_COUNTRIES;t++) cards[t]= &countries[t];
  if (joker) for(;t<NUM_CARDS;cards[t++]= &Joker);
  cards[t] = NULL;
  for(t1=0;cards[t1];t1++)
    {
      r = Random(t);
      Switch(cards[t1],cards[r],sw);
    }
}

/* Distribute countries to all players */
void distribute_countries()
{
  int t;
  
  find_shuffle_cards(NO_JOKER);
  for(t=0;t<NUM_COUNTRIES;t++) 
    {
      players[t%num_players]->conquests[t/num_players]=cards[t];
      cards[t]->occupant=players[t%num_players];
    }
  for(;t<NUM_COUNTRIES+num_players;t++) 
    players[t%num_players]->conquests[t/num_players]=NULL;
}

/* Initialize the game */
void init_play(mach)
     char **mach;
{
  init_states();
  init_countries();
  init_players(mach);
  distribute_countries();
  find_shuffle_cards(WITH_JOKER);
  distribute_mission();
}
