#include "xrisk.h"
#include "risklibex.h"

/*
unsigned char noise[1<<19];

* Just read random numbers from a file *
* Supported by Kim Oyehus kim@lise.unit.no *
float ran_Kim()
{
  static int virgin=1, seed=0;
  int        n,a;
  FILE      *stream;

  seed=(long int)time((time_t *)0);
  seed%=1<<19;
  if(virgin)
    {
      stream=fopen("../random_data/random.bin","r");
      for(n=0; n<1<<19; n++) noise[n]=fgetc(stream);
      fclose(stream);
      virgin=0;
    }
  a=noise[seed++];
  a=(a<<8)+noise[seed++];
  a=(a<<8)+noise[seed++];
  return((float)a/(1<<24));
}


#define rnd_mult 1566083941L 
unsigned long random_risk()
{
  static unsigned long int seed=0;
  
  if (!seed)
    {
      seed=(long int)time((time_t *)0);
      srandom((int)time((time_t *)0)); 
      srand48((long)time((time_t *)0));
    }
  seed = rnd_mult * seed + 1;
  return(seed*(unsigned long)lrand48()*(unsigned long)random());
}

float ran0()
{
  static     float y,maxran,v[98];
  float      dum;
  static int iff=0;
  int        j;
  unsigned   i,k;
  static int idum=0;
  
  if (!idum) idum=(int)time((time_t *)0);

  if (idum < 0 || iff == 0) {
    iff=1;
    i=2;
    do {
      k=i;
      i<<=1;
    } while (i);
    maxran=k;
    srand(idum);
    idum=1;
    for (j=1;j<=97;j++) dum+=rand();
    for (j=1;j<=97;j++) v[j]=rand();
    y=rand();
  }
  j=1+97.0*y/maxran;
  if (j > 97 || j < 1) risk_exit("RAN0: This cannot happen.",LAST_ARG);
  y=v[j];
  v[j]=rand();
  return(y/maxran);
}
*/

#define M1 259200
#define IA1 7141
#define IC1 54773
#define RM1 (1.0/M1)
#define M2 134456
#define IA2 8121
#define IC2 28411
#define RM2 (1.0/M2)
#define M3 243000
#define IA3 4561
#define IC3 51349

/* Currently in use */
float ran1()
{
  static long  ix1,ix2,ix3;
  static float r[98];
  float        temp;
  static int   iff=0;
  int          j;
  static int   idum=666;
    
  if ( idum == 666 ) idum= -(int)(time((time_t *)0)%10007);

  if (idum < 0 || iff == 0) {
    iff=1;
    ix1=(IC1-(idum)) % M1;
    ix1=(IA1*ix1+IC1) % M1;
    ix2=ix1 % M2;
    ix1=(IA1*ix1+IC1) % M1;
    ix3=ix1 % M3;
    for (j=1;j<=97;j++) {
      ix1=(IA1*ix1+IC1) % M1;
      ix2=(IA2*ix2+IC2) % M2;
      r[j]=(ix1+ix2*RM2)*RM1;
    }
    idum=1;
  }
  ix1=(IA1*ix1+IC1) % M1;
  ix2=(IA2*ix2+IC2) % M2;
  ix3=(IA3*ix3+IC3) % M3;
  j=1 + ((97*ix3)/M3);
  if ((j > 97) || (j < 1)) 
    risk_exit("RAN1: This cannot happen.(%d)",j,LAST_ARG);
  temp=r[j];
  r[j]=(ix1+ix2*RM2)*RM1;
  return temp;
}

#undef M1
#undef IA1
#undef IC1
#undef RM1
#undef M2
#undef IA2
#undef IC2
#undef RM2
#undef M3
#undef IA3
#undef IC3
