#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <ctype.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <X11/Intrinsic.h>
#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/cursorfont.h>
#include <X11/keysym.h>
#include <X11/keysymdef.h>

#include "functionsdef.h"

/* Font-sizes.... Not aa good way to do it */
#define FONTH             10
#define FILLH              3
#define FONTB              6

/* Maximal number of map-strings */
#define MAX_MAPS         999

/* Max lengt of misc strings */
#define MAXLEN_NMISC      31
#define MAXLEN_MISC      255

/* Max and min length of your name */
#define MAXLEN_NPLAYER     9
#define MINLEN_NPLAYER     1
#define WIDTH_NMISC         MAXLEN_NMISC*FONTB

/* Shuffle cards with or without "joker" */
#define WITH_JOKER         1
#define NO_JOKER           0

/* Last argument to functions with varargs */
#define LAST_ARG            (char *)0xffff

/* The name of all windows ( See also <files>.mapping ) */
#define CARD_WIN_NAME        "#024_Cards - information"
#define INFO_WIN_NAME        "#043_Risk - information"
#define WINNAME              "#049_XRISK"

/* Used to describe the cards (window) */
#define UNITX             120		/* Width pic of soldier       */
#define UNITY             100   	/* Height pic of soldier      */
#define BORDERX           120		/* Width pic of borders       */
#define BORDERY           120   	/* Height pic of borders      */
#define CARDS_MAX_PLAYER   50   	/* Max number of cards player */
#define CARDS_MAX_SHOWN    10   	/* Max number of cards shown  */
#define CARDS_ROW           5   	/* Cards in each row          */
#define C_FRAME             1           /* Width of frame             */
#define C_WIDTH           120   	/* Width of cards             */
#define C_HEIGHT          240   	/* Height of cards            */
#define CF_WIDTH             (C_WIDTH+2*C_FRAME) /* Width of card with frame */
#define CF_HEIGHT            (C_HEIGHT+2*C_FRAME)/* Height of card w. frame  */
#define C_SPACE 	    3                    /* Space between cards      */
#define C_BUTTONH            2*FONTH             /* Height of but. to press  */
#define C_BUTTONW            C_WIDTH             /* Width of but. to press   */
#define CF_BUTTONW           (C_BUTTONW+2*C_FRAME) /* Width with frame */
#define CF_BUTTONH           (C_BUTTONH+2*C_FRAME) /* Height with frame */
#define UNIT0                "#161_artillery" /* Names */
#define UNIT1                "#162_infantry"  /* Names */
#define UNIT2                "#163_cavalry"   /* Names */
#define JOKER                "#164_joker"     /* Names */
#define V_UNIT0             1   /* Used to identify cards when exchanging */
#define V_UNIT1            10   /* Used to identify cards when exchanging */
#define V_UNIT2           100   /* Used to identify cards when exchanging */
#define V_JOKER          1000   /* Used to identify cards when exchanging */

/* Used to descrbe map-window */
#define XSIZE             800   /* Width of map */
#define YSIZE             800   /* Height of map */
#define TEXTX              80   /* Where to write position of cursor       */
#define TEXTY             750   /* Where to write position of cursor       */
#define MSGX                 (TEXTX+WIDTH_NMISC) /* Where to write private */
#define MSGY                 (TEXTY)             /* messages               */
#define MSGLEN               (XSIZE-MSGX)        /* And the length of them */
#define SCWINX            410                        /* Where to place the */
#define SCWINY              0                        /* scroll - window    */
#define SCWINL               (XSIZE-2-SCWINX)        /* And the size       */
#define SCWINH            100                        /* of it              */
#define SCWINR              1                        /* Thickness of frame */
#define SCLINES              (SCWINH/(FONTH+FILLH))  /* Number of lines    */
#define MENU_H             17             /* Hight menu buttons upper left */
#define MENU_B            150             /* Width menu buttons upper left */ 

/* How do write a sentence */
#define CENTER              1    /* Senter it */
#define CLR                 2    /* Clear a box with specified size before */
#define DRAWIMAGESTRING     4    /* Use XDrawImageString */
#define BACKCOLOR          42    /* Color of ocean's and backround */
#define FORECOLOR          43    /* Color of borders and writing */

/* Several options ( Most of them yet to be implemented )*/
#define MISSION                  0x0001  /* Want missions ?                  */
#define GET_CARDS_ON_KILL        0x0002  /* Get cards from your victims      */
#define LOOSE_CARDS_ON_SUICIDE   0x0004  /* Explains itself                  */
#define SEQ_PLACEMENT_START      0x0008  /* Or paralell plasement            */
#define NO_SUICIDE               0x0010  /* Let players kill themself        */
#define VOTE_FOR_SUICIDE         0x0020  /* Semi - suicide - solution        */
#define ONE_ARMY_EACH_COUNTRY    0x0040  /* Initially armies on the map      */
#define ENABLE_TALK_WINDOW       0x0080  /* Automaticly start xmtalk ?       */
#define CARD_WINDOW_SMALL        0x0100  /* Get aa small cardswindow         */
#define GET_CARD_REL_ARMIES      0x0200  /* Why not ???                      */
#define TWO_ACTIVE_PLAYERS       0x0400  /* Two active players(buggy)        */
#define DEFAULT_OPTIONS          MISSION /* Default settings                 */

/* Individual temporary options available to each player ( Buttons ) */
#define DO_OR_DIE           1

/* For the user to define */
#define ARMIES_START       30    /* Armies to start with */
#define MAX_ARMIES_START    7    /* Max. armies in each county when we start */
#define FREE_MOVES          7    /* Max. free moves                          */

/* The information - window */
#define WIDTH_BUTT         19    /* Width button */
#define SPACE               2    /* Space between buttons */
#define FRAME               1    /* With of frame */
#define CHAR_WIDTH_COL     11    /* Max. number of characters in colomn */
#define WIDTH_COL            (CHAR_WIDTH_COL*FONTB+FRAME)   /* Width colomn  */
#define START_COL            (WIDTH_BUTT+2*(SPACE+FRAME))   /* First colomn  */
#define HEIGHT_ROWS          (WIDTH_BUTT+SPACE+2*FRAME)     /* Hight colomn  */
#define DX_KOL               (WIDTH_COL-FRAME)    /* Area to clear in colomn */
#define START_TEXT_X         (START_COL+FRAME)    /* Where to place text     */
#define START_TEXT_Y         ((HEIGHT_ROWS+FONTH)/2+FILLH)  /* in x,y coords */
#define NUM_COL             8	/* Number of colums             */
#define U_NAME_PLAYER       0   /* Update name of player        */
#define U_COUNTRIES         1	/* Update name of coutries      */
#define U_CONTINENTS        2   /* Update numb of continents    */
#define U_CARDS             3   /* Update numb of cards         */
#define U_ARMIES            4   /* Update numb of forces        */
#define U_ARMIES_LOST       5   /* Update numb of forces lost   */
#define U_ARMIES_KILLED     6   /* Update numb of forces killed */
#define U_ARMIES_GAINED     7   /* Update numb of forces gained */
#define O_ALL               8   /* Update all fields            */
#define ALL_THE_TEXT         {"#039_Name","#026_Country","#037_Continent","#023_Card","#019_Armies","#038_Lost","#036_Killed","#031_Gained"} /* Text */

/* How to update infowin and some other places when we get/loose/move armies */
#define UPDATE              1   /* These armies we gained or lost  */
#define NO_UPDATE           0   /* These armies we are just moving */

/* Defining defining */
#define NUM_COLORS         64   /* Numbers of colors we allocate           */
#define NUM_COUNTRIES      42   /* Numbers of countries on the map         */
#define MAX_MISSIONS       20   /* Number of missions (max)                */
#define NUM_CONTINENTS      6   /* Number of continents                    */
#define NUM_JOKERS          2   /* Numbers of jokers                       */
#define NUM_CARDS            (NUM_COUNTRIES+NUM_JOKERS) /* Number of cards */ 
#define MAX_PLAYERS         8   /* Maximum number of players               */

/* To avoid problems whith litte/big - endian when saving integers on disc */
#define Fgetint(i,s,t)   for((i)=0,t=3;t>=0;t--) (i)+=(fgetc(s)<<(t*8))
#define Fputint(i,s,t)   for(t=3;t>=0;t--) fputc((char)(((i)>>(t*8))&255),s)

#define Do_each_player(t)    for(t=0;t<MAX_PLAYERS;t++) if (players[t])
#define Switch(p1,p2,t)      do{(t)=(p1) ; (p1)=(p2) ; (p2)=(t) ;}while(0)
#define Get_index_coord(x,y) map[(x)+(y)*XSIZE]
#define Random(i)            ( (unsigned) (i*ran1()))
#define Throw_dice()         (Random(6)+1)
#define Min(a,b)             ((a)<(b)?(a):(b))
#define Max(a,b)             ((a)>(b)?(a):(b))
#define Chosen(I,i)          ( (I) &  (1<< (i)) )
#define Choose(I,i)          ( (I) ^= (1<< (i)) )	     
#define Clr(I,i)             ( (I) &= (255^(i)) )
#define SetFlag(s,i)         ( (s->attr.attr_game) |= (i) )
#define ClrFlag(s,i)         ( (s->attr.attr_game) &= (255^(i)) )
#define SwitchFlag(s,i)      ( (s->attr.attr_game) ^= (i) )
#define FlagSet(s,i)         ( (s->attr.attr_game) &  (i) )
#define GetEvent(s)          ( (s)->pstat->event )
#define GetEventp(s)         ( &((s)->pstat->event) )
#define RegEvent(s)          XCheckMaskEvent(s->xcon->disp,\
			     KeyPressMask|ButtonPressMask|ExposureMask,\
			     &(s->pstat->event))
#ifndef XRASDIR
#define XRASDIR              "/home/lise1d/nordeng/src/c/risk/xras"
#endif
#ifndef MAPDIR
#define MAPDIR               "/home/lise1d/nordeng/src/c/risk/languages"
#endif
#ifndef DATAFILE
#define DATAFILE             "/home/lise1d/nordeng/src/c/risk/data/risk.data"
#endif
#ifndef LANGUAGE
#define LANGUAGE             "norwegian"
#endif
#define PICTURFILE           "#156_world"
#define EXTENTION            ".xras"


#define Country Card   /* Use same struct to represent a card and a country */

typedef unsigned char             byte;
typedef struct Country           *countryp;
typedef struct Continent         *continentp;
typedef struct Player            *playerp;
typedef struct Mission           *missionp;
typedef struct Xcon              *xconp;
typedef struct Info_Win          *info_winp;
typedef struct Card_Win          *card_winp;
typedef struct Card              *cardp;
typedef struct PStat             *pstatp;
typedef struct Action            *actionp;
typedef struct State             *statep;
typedef struct Risk_Cursors      *risk_cursorsp;
typedef struct Actions_Other_Win *actions_other_winp;
typedef struct Button_Actions    *button_actionsp;
typedef struct Control_Actions   *control_actionsp;
typedef struct Control_Data      *control_datap;
typedef struct All_Actions       *all_actionsp;

/* These options should be possible to set when starting the game */
struct Game_Options
{
  int   armies_start;      /* Number of armies to distribute initially       */
  int   max_armies_start;  /* Max. numb. of armies in each country initially */
  int   options;           /* Several options defined above (bits/flags)     */
  char *language;          /* What language to use                           */
};

/* The structure parsed by the function do_action */
struct Action
{
  int (*func)();           /* Which function to call                  */
  int next_state[2];       /* Which state is next if any state at all */
};

/* Functions controlling the behaviour of the game */
struct Control_Actions
{
  int index;               /* Which control action                 */
  int index_next;          /* Which control action next            */
  int c_state;             /* Which player-state to check for      */
  int (*c_func)();         /* The control-action                   */
  int next_state;          /* Which stat to give the player ....   */
};

/* A table to show where the players are and the control-state */
struct Control_Data
{
  int              *who_where;      /* Players in the state we're watching */
  control_actionsp control_action;  /* See above                           */
};

/* What to do if we get a button-event */
struct Button_Actions
{
  struct Action  action_mB1; /* Button-event for mouse-buton1 */
  struct Action  action_mB2; /* Button-event for mouse-buton2 */
  struct Action  action_mB3; /* Button-event for mouse-buton3 */
};

/* Actions beloning to the map-window */
struct All_Actions
{
  int                    state;           /* Which state this is          */
  int                    next_state;      /* Next natural state           */
  struct Action          init_func;       /* Function to initialize state */
  struct Action          func;            /* Function to call continously */ 
  struct Button_Actions  map_but_actions; /* Handling of mouse-events     */
  struct Action          action_kB;       /* Handling of keypress-events  */
  struct Action          spec_func;       /* Handling of special event    */
  struct Action          exit_func;       /* Function when exiting state  */
};


/* Attach events to a Window */
struct Actions_Other_Win
{
  int                    index;           /* Intern index of this window   */
  struct Button_Actions  button_actions;  /* Actions when events in window */
};

/* Which cursors we want to use */
struct Cursor_Table
{
  int              index;                  /* Intern index of this cursor  */
  unsigned int     shape;                  /* The shape of the cursor      */
};

/* Which cursor to which window and in what state */
struct Risk_Cursors
{
  int state;    /* Which state             */
  int map;      /* Cursor in map-window    */
  int cards;    /* Cursor in card-window   */
  int info;     /* Cursor in info-window   */
  int scroll;   /* Cursor in scroll_window */
};

/* All information needed about each state */
struct State
{
  int                  state;             /* Index of state                  */
  int                 *who_where;         /* Players in this state           */
  all_actionsp         all_actions;       /* Actions in mapwindow            */
  actions_other_winp   actions_other_win; /* Actions in other windows        */
  risk_cursorsp        risk_cursors;      /* Cursors belonging to this state */
};

/* Some data used by functions called, more like a working area  */
struct PStat
{
  playerp        player;
  int            return_state;
  XEvent         event;              /* What event was the last             */
  char           genstring[1024];    /* Used when getting text from player  */
  char          *string[1024];       /* Might need some more strings        */
  Window         win;                /* Usely the window in which to write  */
  int            flags,strlen,strmin,strmax,x,y,dx,dy; /* Getting text      */
  int            clear_field;        /* Want to clear field after used it ? */
  unsigned long  fc,bc;              /* Foregroundcolor, Backgroundcolor    */
  countryp       country,from,target;/* Move/attack/misc. from -> target    */
  int            flag,armies_max,armies_min,armies_left,armies_move; /* sth */
  int            (*funk1)(),(*funk2)(),(*funk3)(); /* Might come handsome   */
  Window         spec_win;           /* Window in where to expect events    */
  time_t         exit_press;         /* Last press in suecide-window ??     */
};

/* This attributes is uniq to each player and changable during play */
typedef struct
{
  int attr_game;       /* Do or die, etc.            */
  int attack_armies;   /* Number of attacking armies */
} Attribs;

/* Information about the card-window */
struct Card_Win
{
  playerp               player;      /* Who owns it                          */
  XSetWindowAttributes  attr;        /* Attributes                           */
  unsigned long         attrmask;    /* Attribute-mask                       */
  XSizeHints           *s_h;         /* Size of window                       */
  Window                win;         /* Window id                            */
  struct Card         **card;        /* Cards it holds                       */
  XImage               *aimage[3];   /* Images of avelinger                  */
  XImage               *gimage[CARDS_MAX_PLAYER]; /* Images of countries     */
  XSizeHints           *k_h[CARDS_MAX_SHOWN];     /* Size subwindows         */
  XSizeHints           *b_h[CARDS_MAX_SHOWN];     /* Size subwindows         */
  Window                cards[CARDS_MAX_SHOWN];   /* Subwindow id's          */
  Window                buttons[CARDS_MAX_SHOWN]; /* Subwindow id's          */
  int                   chosen,exchange,allow_ch; /* Some status-information */
};

/* Information concerning the info-window */
struct Info_Win
{
  XSetWindowAttributes  attr;                     /* Attributes           */
  unsigned long         attrmask;                 /* Attribute mask       */
  XSizeHints           *s_h,*u_h,*l_h;            /* Size of windows      */
  XWMHints             *wmh;                      /* To set InputHint     */
  Window                win,upper,lower;          /* Window id's          */
  Window                button,child[NUM_COLORS]; /* Button window id's   */
};

/* Information about Xconection and the mapwindow */
struct Xcon
{
  Display              *disp;      /* Display connected to player           */
  int                   scr;       /* Screen connected to player            */
  GC                    gc;        /* Graphic Contest connected to player   */
  Screen               *screen;    /* Screen of this player                 */
  Window                win,root,scrollwin,menu_butt[MENU_NUMB]; /* Windows */
  XImage               *ximage;    /* Image of the map                      */
  XSetWindowAttributes  attr;      /* Attributes when opening the mapwindow */
  unsigned long         attrmask;  /* Which attributes we whish to set      */
  Visual               *visual;    /* Visual connected to player            */
  unsigned int          depth;     /* Depth of screen                       */
  Colormap              cmap;      /* Common colormap to all windows        */
  Cursor                cursors[NUMB_CURSORS]; /* List of all cursors       */
  unsigned long         pixm[NUM_COLORS];      /* List of all colors        */
  unsigned long         black,white;           /* Very special colors       */
  int                   indexs;    /* Index of this player                  */
};

/* Information about each player */
struct Player
{
  char                name[MAXLEN_NPLAYER+1]; /* The players name            */
  char                client[MAXLEN_NMISC+1]; /* Name of the players machine */
  XColor             *colors[MAX_PLAYERS];    /* Colortable of all players   */
  struct Card        *card[CARDS_MAX_PLAYER+1];   /* Possesed cards          */
  struct Country     *conquests[NUM_COUNTRIES+1]; /* List of conquests       */
  missionp            mission;                /* The players mission or NULL */
  xconp               xcon;                   /* Connection to X-server      */
  card_winp           card_win;               /* Cards-window                */
  info_winp           info_win;               /* Information-window          */
  statep              state;                  /* Pointer to state            */
  pstatp              pstat;                  /* State-working-area          */
  Attribs             attr;                   /* Changable attributes        */
  int                 offensiv;               /* Have i been offensive ??    */
  int                 num_cards;              /* Number of cards I've got    */
  int                 num_conquests;          /* Number of conguests         */
  int                 num_continents;         /* Number of continents        */
  int                 num_armies_gained;      /* Total num. of armies gained */
  int                 num_armies,armies_lost,armies_killed;   /* Statistics  */
  int                 indexs;                 /* Index of this player        */
};

/* Info about missions */
struct Mission
{
  char                  sentence[MAXLEN_MISC+1]; /* The mission written out  */
  playerp               victim;        /* Who to kill                        */
  struct Continent    **conquestscont; /* Which continents to conquer        */
  int                   conquestsc;    /* How many countries to conquer      */
  int                   army;          /* How many armies in each country    */
};

/* Information about each coutry/card */
struct Country
{
  char                  name[MAXLEN_NMISC+1]; /* Name of country        */
  playerp               occupant;             /* Who is the ocupant     */
  int                   number;               /* Number of armies       */
  struct Country      **neighbours;           /* What neigbours         */
  continentp            continent;            /* In what continent      */
  char                  unit[MAXLEN_NMISC+1]; /* Name army unit         */
  int                   indexunit;            /* Index of unit          */
  char                 *border;               /* Borderpicture raster   */
  int                   x,y;                  /* Something              */
  int                   indexl;               /* Index of land          */
  int                   value;                /* When changing cards    */
};

/* Info about each continent */
struct Continent
{
  char                  name[MAXLEN_NMISC+1];   /* Name of continent         */
  struct Country      **countries;              /* Countries in continent    */
  int                   weight;                 /* Armies to get on conquest */
};

extern struct Player       *players[MAX_PLAYERS+1]; /* List of all players   */
extern struct Card         *cards[NUM_CARDS+1];     /* List of cards not out */
extern struct Continent     continents[NUM_CONTINENTS]; /* List of continents*/
extern struct Mission      *missions[MAX_MISSIONS+1];   /* List of missions  */
extern struct Country       countries[NUM_COUNTRIES];   /* List of countries */
extern struct Continent     free_choise;         /* Continent of free choice */
extern struct Country       Joker;               /* The joker                */
extern XColor               colors[MAX_PLAYERS]; /* Basis color-table        */
extern char                *sentencemapping[MAX_MAPS];  /* List of mappings  */
extern char                *map;             /* Byte-representation of map   */
extern char                *unitp[3];        /* Byte-representation of units */
extern int                  num_players;     /* Players still alive          */
extern struct State        *states[NUM_STATES];   /* Availible states        */
extern struct Control_Data  control_data;         /* Status of the game      */
extern int                  who_where[NUM_STATES];/* Which player, what state*/
extern struct Game_Options  game_options;         /* Options in this game    */
