#include "xrisk.h"
#include "risklibex.h"
#include "xriskex.h"
#include "cardex.h"
#include "randomex.h"
#include "actions_menu_but.h"
#include "control_statesex.h"

/* Get a mission that not implies killing yourself */
missionp get_mission(player)
     playerp player;
{
  int      t,which;
  missionp retur;
  
  for(t=0;missions[t];t++);
  do which = Random(t);
  while( missions[which]->victim == player );
  retur           = missions[which];
  missions[which] = missions[t-1];
  missions[t-1]   = (missionp)NULL;
  return(retur);
}

/* Put mission back as unused */
void deliver_mission(mission)
     missionp mission;
{
  int t;
  for(t=0;missions[t];t++);
  missions[t]   = mission;
  missions[t+1] = (missionp) NULL;
}

/* Write a message. in one of the buttons */
int write_button(xinfo, butt_nr, curs_nr, msg)
     xconp  xinfo;
     int    butt_nr, curs_nr;
     char  *msg;
{
  write_line(xinfo,xinfo->menu_butt[butt_nr],-1,-1,0,FONTH+FILLH
	     ,MENU_B,-1,msg,CENTER|CLR);
  XDefineCursor(xinfo->disp,xinfo->menu_butt[butt_nr],xinfo->cursors[curs_nr]);
  return(0);
}

/* Give a country the color of it,s inhabitant */
void set_color(player, country)
     playerp player;
     countryp country;
{
  int t;
  
  if (player)
    {
      player->colors[country->occupant->indexs]->pixel=
	player->xcon->pixm[country->indexl];
      XStoreColor(player->xcon->disp,player->xcon->cmap,
		  player->colors[country->occupant->indexs]);
      XFlush(player->xcon->disp);
    }
  else Do_each_player(t) set_color(players[t],country); 
}

/* Write number of armies in a country */
void write_num_armies(xinfo, country)
     xconp xinfo;
     countryp country;
{
  int t;
  
  if (xinfo)
    {
      char text[5];
      sprintf(text,"%3d",country->number);
      write_line(xinfo,xinfo->win,-1,xinfo->pixm[country->indexl]
		 ,country->x,country->y,-1,-1,text,CLR);
    }
  else Do_each_player(t) write_num_armies(players[t]->xcon,country);
}

/* Store static colors */
int update_colors(player)
     playerp player;
{
  xconp xinfo;
  int   t;
  
  /* Use of colors */
  /*  0 Tom. 43 used on the map */
  /* 44 Tom. 49 not used        */
  /* 50 Tom. 58 playercolors    */
  /* 59 Tom. 63 not used        */
  
  xinfo = player->xcon;
  XStoreNamedColor(xinfo->disp,xinfo->cmap,"black",
		   xinfo->pixm[BACKCOLOR],DoRed|DoGreen|DoBlue);
  XStoreNamedColor(xinfo->disp,xinfo->cmap,"white",
		   xinfo->pixm[FORECOLOR],DoRed|DoGreen|DoBlue);
  xinfo->black = xinfo->pixm[BACKCOLOR];
  xinfo->white = xinfo->pixm[FORECOLOR];
  for(t=0;t<MAX_PLAYERS;t++)
    {
      colors[t].pixel=xinfo->pixm[50+t];
      XStoreColor(xinfo->disp,xinfo->cmap,&colors[t]);
    }
  return(0);
}

/* When we have to redraw the map after an exposure-event */
int expose_mapwin(player)
     playerp player;
{
  XExposeEvent *pexposeevent;
  xconp         xinfo;
  int           t;
  
  pexposeevent = &(GetEventp(player)->xexpose);
  xinfo  = player->xcon;
  
  XPutImage(xinfo->disp,xinfo->win,xinfo->gc,xinfo->ximage,
	    pexposeevent->x,     pexposeevent->y,
	    pexposeevent->x,     pexposeevent->y,
	    pexposeevent->width, pexposeevent->height);
  if (!pexposeevent->count) 
    for(t=0;t<NUM_COUNTRIES;t++) write_num_armies(xinfo,&countries[t]);
  write_msg(player,NULL);
  return(0);
}

int expose_action_menu(player, menunumber)
     playerp player;
     int menunumber;
{
  if (!GetEventp(player)->xexpose.count) do_action
    (player,&(actions_menu_but[menunumber].button_actions.action_mB2));
  return(0);
}

/* Redraw & etc. the mapwindow */
int update_mapwin(player)
     playerp player;
{
  xconp xinfo;
  int   t;
  
  xinfo=player->xcon;
  XPutImage
    (xinfo->disp,xinfo->win,xinfo->gc,xinfo->ximage,0,0,0,0,XSIZE,YSIZE);
  for(t=0;t<NUM_COUNTRIES;t++)
    {
      set_color(player,&countries[t]);
      write_num_armies(xinfo,&countries[t]);
    }
  for(t=0;t<MENU_NUMB;t++) do_action
    (player,&(actions_menu_but[t].button_actions.action_mB2));
  write_msg_all((char *)NULL);
  return(0);
}

/* Draws the info-window after a person has chosen his colour */
void settopp_infowin(player)
     playerp player;
{
  int          t;
  static char *kolonner[] = ALL_THE_TEXT;
  xconp        xinfo;
  info_winp    infowin;
  
  xinfo   = player->xcon;
  infowin = player->info_win;
  
  XSetForeground(xinfo->disp,xinfo->gc,xinfo->white);
  for(t=0;t<NUM_COL;t++) 
    {
      write_line(xinfo,infowin->upper,-1,-1,t*WIDTH_COL+START_TEXT_X,
                 START_TEXT_Y,DX_KOL,-1,kolonner[t],CENTER);
      XDrawLine
        (xinfo->disp,infowin->upper,xinfo->gc,
         t*WIDTH_COL+START_COL,0,
         t*WIDTH_COL+START_COL,infowin->u_h->height);
      XDrawLine
        (xinfo->disp,infowin->lower,xinfo->gc,
         t*WIDTH_COL+START_COL,0,
         t*WIDTH_COL+START_COL,infowin->l_h->height);
    }
  
  /* We want the name of those who have allready chosen one */
  for(t=0;players[t];t++)
    if(players[t]->state->state > GET_NAME) write_line
      (xinfo,infowin->lower,-1,-1,START_TEXT_X,START_TEXT_Y+t*HEIGHT_ROWS,
       DX_KOL,-1,players[t]->name,CENTER);
}

/* Update values of armies lost etc. */
int update_infowin(player, difference, flag)
     playerp player;
     int difference;
     int flag;
{
  int  *number=NULL,t;
  char *string=NULL,msg[5];
  
  if (flag == U_NAME_PLAYER)   string = player->name;
  if (flag == U_COUNTRIES)     number = &(player->num_conquests);
  if (flag == U_CONTINENTS)    number = &(player->num_continents);
  if (flag == U_CARDS)         number = &(player->num_cards);
  if (flag == U_ARMIES_LOST)   number = &(player->armies_lost);
  if (flag == U_ARMIES_KILLED) number = &(player->armies_killed);
  if (flag == U_ARMIES)        number = &(player->num_armies);
  if (flag == U_ARMIES_GAINED) number = &(player->num_armies_gained);
  if (flag == O_ALL)
    {
      for(t=0;t<NUM_COL;t++) update_infowin(player,0,t);
      return(0);
    }
  
  if ((!string)&&(!number)) risk_exit
    ("Mistak for flag %d, no arguments to update player %s\n",
     flag,player->name,LAST_ARG);
  if (number) 
    {
      *number+=difference;
      if ((*number<0)||(*number>9999)) risk_exit
	("Mistak in update flag %d  Number: %d : Player : %s\n",
	 flag,*number,player->name,LAST_ARG);
      sprintf(msg,"%3d",*number);
      string=msg;
    }
  if (flag<NUM_COL) Do_each_player(t) if (players[t]->state->state > GET_NAME)
    write_line(players[t]->xcon,players[t]->info_win->lower,-1,-1,
	       START_TEXT_X+flag*WIDTH_COL,
	       START_TEXT_Y+player->indexs*HEIGHT_ROWS,
	       DX_KOL,-1,string,CLR|CENTER);
  return(0);
}

int expose_infowin(player)
     playerp player;
{
  int t;
  XExposeEvent *pexposeevent;
  
  pexposeevent = &(GetEventp(player)->xexpose);
  if (pexposeevent->count || player->state->state < GET_NAME) return(1);
  
  settopp_infowin(player);
  if (player->state->state < CHECK_NAME) return(0);
  
  Do_each_player(t) update_infowin(players[t],0,O_ALL);
  
  return(0);
}

/* Lookup country based on map-coorinats */
countryp find_country_coord(x, y)
     int x, y;
{
  int temp;
  if((x<0)||(x>=XSIZE)||(y<0)||(y>=YSIZE)) return(NULL);
  temp=Get_index_coord(x,y);
  if((temp>=0)&&(temp<NUM_COUNTRIES)) return(&countries[temp]);
  return(NULL);
}

/* Check if a player has conquered aa continent */
int conquered_continent(player, continent)
     playerp player;
     continentp continent;
{
  int t;
  if ((continent == &free_choise) && (player->num_continents)) return(1);
  for(t=0;continent->countries[t]
      &&(continent->countries[t]->occupant==player);t++);
  if (continent->countries[t]) return(0);
  return(1);
}

/* Check if two countries are neighbours */
int neighbours(country1, country2)
     countryp country1;
     countryp country2;
{
  int t;
  for(t=0;country1->neighbours[t]&&(country1->neighbours[t]!=country2);t++);
  if (country1->neighbours[t]) return(1);
  return(0);
}

/* Armies lost/moved from this country. Update statistics. */
int sub_armies(from, murderer, number, flag)
     countryp from;
     playerp murderer;
     int number, flag;
{
  number        = Min(number,from->number);
  from->number -= number;
  write_num_armies((xconp)NULL,from);
  if (flag&UPDATE)
    {
      update_infowin(from->occupant,-number,U_ARMIES);
      update_infowin(from->occupant, number,U_ARMIES_LOST);
      update_infowin(murderer      , number,U_ARMIES_KILLED);
    }
  return(from->number);
}

/* Armies gained or moved to a country. Update statistics. */
int add_armies(target, number, flag)
     countryp target;
     int number, flag;
{
  target->number += number;
  write_num_armies((xconp)NULL,target);
  if (flag&UPDATE) 
    {
      update_infowin(target->occupant,number,U_ARMIES);
      update_infowin(target->occupant,number,U_ARMIES_GAINED);
    }
  return(target->number);
}

/* A player move armies between countries or add armies to a coutry */
/* Update statistics.                                               */
int move_armies(from, target, num)
     countryp from, target;
     int num;
{
  int flag;
  
  if (!num) return(1);
  
  if (from && from->occupant == target->occupant) flag = NO_UPDATE;
  else                                            flag = UPDATE;
  
  if (from)
    {
      sub_armies(from,NULL,num,flag);
      add_armies(target,num,flag);
      if (num==1) write_msg_all_arg
	("#013_%s moved 1 army from %s to %s",target->occupant->name,
	 from->name,target->name,LAST_ARG);
      else write_msg_all_arg
	("#012_%s moved %d armies from %s to %s",target->occupant->name,num,
	 from->name,target->name,LAST_ARG);
      return(0);
    }
  if (num==1) write_msg_all_arg("#015_%s placed 1 army in %s",
				target->occupant->name,target->name,LAST_ARG);
  else write_msg_all_arg("#014_%s placed %d armies in %s",
			 target->occupant->name,num,target->name,LAST_ARG);
  add_armies(target,num,flag);
  return(0);
}

/* A player who dismissed one of his windows */
void free_player(player)
     playerp player;
{
  XCloseDisplay(player->xcon->disp);
  free(player->xcon);
  player->xcon                       = NULL;
  players[player->indexs]            = NULL;
  (who_where[player->state->state]) ^= (1<<player->indexs);
}

/* Update when a player doesn't participate in the game anymore */
void parse_killed(player)
     playerp player;
{
  write_button(player->xcon,MENU_EXIT,RISK_DIE,"#030_END GAME");
  player->mission            = NULL;
  player->card_win->allow_ch = 0;
  num_players--;
  new_state(player,END_GAME);
}

/* What to happen when aa player get's killed */
void player_killed(murderer, victim)
     playerp murderer, victim;
{
  if (victim->state->state < END_GAME) 
    {
      parse_killed(victim);
      write_msg_arg(victim,"#011_%s killed you (an impressive feat)",
		    murderer->name,LAST_ARG);
      write_msg_all_arg("#010_%s killed %s",murderer->name,victim->name,
			LAST_ARG);
    }
  else
    {
      write_msg_arg(victim,"#017_%s exterminated your armies",
		    murderer->name,LAST_ARG);
      write_msg_all_arg("#016_%s exterminated the armies of the late %s",
			murderer->name,victim->name,LAST_ARG);      
    }
  transfer_all_cards(victim,murderer);
}

/* Do you have armies to move anywhere ?? */
int op_move_armies(player)
     playerp player;
{
  int t;
  for(t=0;(player->conquests[t])&&(player->conquests[t]->number==1);t++);
  if (player->conquests[t]) return(1);
  else return(0);
}

/* Done whene a player gets a coutry */
void add_country(countrylist,country)
     struct Country **countrylist;
     countryp country;
{
  int t;
  for(t=0;countrylist[t];t++);
  countrylist[t++] = country;
  countrylist[t]   = NULL;
  update_infowin(countrylist[0]->occupant,1,U_COUNTRIES);
  if (conquered_continent(countrylist[0]->occupant,country->continent))
    update_infowin(countrylist[0]->occupant,1,U_CONTINENTS);
}

/* Done when a player looses one country */
void sub_country(countrylist,country)
     struct Country **countrylist;
     countryp country;
{
  int t;
  if (conquered_continent(countrylist[0]->occupant,country->continent))
    update_infowin(countrylist[0]->occupant,-1,U_CONTINENTS);
  update_infowin(countrylist[0]->occupant,-1,U_COUNTRIES);
  
  for(t=0;countrylist[t]&&(countrylist[t]!=country);t++);
  if (!countrylist[t]) risk_exit
    ("Could not find the country %s in sub_country\n",country->name,LAST_ARG);
  for(;countrylist[t];t++) countrylist[t]=countrylist[t+1];
  countrylist[t-1]=NULL;
}

/* Has this player achieved his mission  ??? */
int achieved_mission(player)
     playerp player;
{
  missionp mission;
  int      t,count;
  
  if (!(mission=player->mission)) return(0);
  if (mission->victim) 
    if (mission->victim->state->state >= END_GAME) return(1);
    else                                           return(0);
  if (mission->conquestscont)
    {
      for(t=0;(mission->conquestscont[t])
	  &&(conquered_continent(player,mission->conquestscont[t]));t++);
      if (mission->conquestscont[t])   return(0);
      if (t>player->num_continents) return(0);
      return(1);
    }
  for(t=0,count=0;player->conquests[t];t++)
    if (player->conquests[t]->number>=mission->army) count++;
  if (count < mission->conquestsc) return(0);
  return(1);
}

/* Has any player achieved his mission */
int check_mission(player)
     playerp player;
{
  int t;
  if (player && achieved_mission(player)) done_mission(player);
  else Do_each_player(t) 
    if (achieved_mission(players[t])) players[t]->mission = NULL;
  return(0);
}

/* Number of armies to get at the start of your turn */
int new_armies(player)
     playerp player;
{
  int armies=0,t;
  
  for(t=0;player->conquests[t];t++);
  armies                       += t/3;
  if(armies<3) armies           = 3;
  if (player->offensiv) armies += 1;
  for(t=0;t<NUM_CONTINENTS;t++) if (conquered_continent(player,&continents[t]))
    armies+=continents[t].weight;
  return(armies);
}

/* Simulates the attack on an enemy */
int attack(attacker, defender)
     countryp attacker, defender;
{
  int num_d_attacker,num_d_defender;
  int throw,throwd1,throwd2,throwa1,throwa2,t,sw;
  
  do
    {
      num_d_attacker = (attacker->number-1);
      num_d_defender = defender->number;
      
      num_d_defender = Min(num_d_defender,2);
      num_d_attacker =
	Min(num_d_attacker,attacker->occupant->attr.attack_armies);
      
      throwd1 = Throw_dice();
      throwd2 = Throw_dice();
      if ((throwd1<throwd2)&&(num_d_defender==2)) Switch(throwd1,throwd2,sw);
      
      throwa1 = throwa2 = 0;
      
      for(t=0;t<num_d_attacker;t++)
	if ((throw=Throw_dice())>throwa2)
	  if (throwa1<(throwa2=throw)) Switch(throwa1,throwa2,sw);
      
      if (throwa1>throwd1) sub_armies(defender,attacker->occupant,1,UPDATE);
      else                 sub_armies(attacker,defender->occupant,1,UPDATE);
      
      if ((num_d_attacker>1)&&(num_d_defender>1))
	if (throwa2>throwd2) sub_armies(defender,attacker->occupant,1,UPDATE);
	else                 sub_armies(attacker,defender->occupant,1,UPDATE);
    }
  while(FlagSet(attacker->occupant,DO_OR_DIE) 
	&& (attacker->number > 1) && defender->number );
  return(num_d_attacker);
}
